/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     AND = 258,
     AS = 259,
     CONST = 260,
     DEF = 261,
     DIV = 262,
     ELSE = 263,
     EXTERN = 264,
     IF = 265,
     IMPORT = 266,
     INCLUDE = 267,
     MOD = 268,
     NOT = 269,
     OR = 270,
     OTHERWISE = 271,
     PRIVATE = 272,
     PUBLIC = 273,
     SPECIAL = 274,
     THEN = 275,
     TYPE = 276,
     UNDEF = 277,
     VAR = 278,
     WHERE = 279,
     DOTDOT = 280,
     CAT = 281,
     DBAR = 282,
     LEQ = 283,
     GEQ = 284,
     NEQ = 285,
     EQUIV = 286,
     STR = 287,
     UID = 288,
     LID = 289,
     QUID = 290,
     QLID = 291,
     STR1 = 292,
     INT = 293,
     FLOAT = 294,
     OP0 = 295,
     OP1 = 296,
     OP2 = 297,
     OP3 = 298,
     OP4 = 299,
     OP5 = 300,
     OP6 = 301,
     OP7 = 302,
     OP8 = 303,
     OP9 = 304,
     ERRTOK = 305,
     EOFTOK = 306
   };
#endif
/* Tokens.  */
#define AND 258
#define AS 259
#define CONST 260
#define DEF 261
#define DIV 262
#define ELSE 263
#define EXTERN 264
#define IF 265
#define IMPORT 266
#define INCLUDE 267
#define MOD 268
#define NOT 269
#define OR 270
#define OTHERWISE 271
#define PRIVATE 272
#define PUBLIC 273
#define SPECIAL 274
#define THEN 275
#define TYPE 276
#define UNDEF 277
#define VAR 278
#define WHERE 279
#define DOTDOT 280
#define CAT 281
#define DBAR 282
#define LEQ 283
#define GEQ 284
#define NEQ 285
#define EQUIV 286
#define STR 287
#define UID 288
#define LID 289
#define QUID 290
#define QLID 291
#define STR1 292
#define INT 293
#define FLOAT 294
#define OP0 295
#define OP1 296
#define OP2 297
#define OP3 298
#define OP4 299
#define OP5 300
#define OP6 301
#define OP7 302
#define OP8 303
#define OP9 304
#define ERRTOK 305
#define EOFTOK 306




/* Copy the first part of user declarations.  */
#line 2 "qc.y"


/* qc.y: yacc source of Q parser and Q compiler main program */

/* Special case constructs (unary minus) and dangling else cause a number of
   parsing conflicts which are resolved correctly. */

/*  Q eQuational Programming System
    Copyright (c) 1991-2002 by Albert Graef
    <ag@muwiinfa.geschichte.uni-mainz.de>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#include "qcdefs.h"

int      	nerrs, nwarns;
bool		hflag, nflag, vflag, Vflag, wflag;
volatile bool   int_sig;
char           *self = "qc", *list = "";

char		signon[] = QC_SIGNON;
char   		usage[] = QC_USAGE;
char		opts[MAXSTRLEN];
char		copying[] = COPYING;
char		helpmsg[] = HELPMSG;

DECLARE_YYTEXT

extern int context;

static int type, fno_min, fno_max;
static short flags, sflags;
static unsigned long argv;

static void start_qualifiers(void), qualifiers(void);
static void add_qualifier(EXPR *x);
static void start_where_clauses(void), end_where_clauses(void),
  add_where_clause(EXPR *l, EXPR *r);

static xvect_t *exprlist(void);
static xvect_t *addexpr(xvect_t *v, EXPR *x);
static xvect_t *groupexpr(xvect_t *v);
static EXPR *tupleexpr(xvect_t *v);
static EXPR *listexpr(xvect_t *v);
static EXPR *streamexpr(xvect_t *v);


/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 63 "qc.y"
typedef union YYSTYPE {
  int ival;
  mpz_t zval;
  double fval;
  char *sval;
  EXPR *xval;
  xvect_t *xvval;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 257 "qc.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 269 "qc.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4154

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  80
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  125
/* YYNRULES -- Number of rules. */
#define YYNRULES  400
/* YYNRULES -- Number of states. */
#define YYNSTATES  702

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   306

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    72,     2,    70,    67,     2,    75,    73,
      60,    61,    68,    55,    53,    56,    64,    69,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    57,    52,
      65,    58,    66,     2,    54,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    76,    63,    77,    71,     2,    74,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    78,    59,    79,    62,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,     8,    12,    16,    19,    22,
      25,    28,    31,    35,    38,    42,    44,    48,    51,    55,
      57,    61,    64,    68,    72,    73,    78,    83,    89,    95,
     102,   103,   110,   111,   119,   120,   127,   128,   136,   137,
     140,   141,   144,   145,   148,   150,   154,   155,   159,   161,
     163,   166,   167,   169,   171,   173,   175,   178,   180,   182,
     184,   186,   188,   189,   194,   195,   200,   203,   209,   213,
     220,   221,   224,   228,   229,   232,   237,   238,   241,   245,
     249,   251,   255,   256,   257,   263,   265,   269,   271,   272,
     277,   278,   283,   284,   291,   292,   295,   298,   301,   303,
     304,   308,   310,   314,   318,   320,   323,   327,   330,   332,
     336,   338,   345,   350,   352,   356,   358,   362,   364,   367,
     371,   374,   376,   380,   382,   389,   394,   396,   400,   402,
     406,   408,   410,   412,   414,   416,   418,   420,   423,   427,
     430,   432,   436,   438,   445,   450,   452,   456,   458,   462,
     464,   468,   472,   474,   478,   480,   483,   486,   489,   492,
     494,   498,   500,   504,   506,   509,   511,   514,   518,   521,
     523,   527,   529,   531,   533,   540,   545,   547,   551,   553,
     555,   557,   561,   563,   565,   567,   569,   571,   573,   575,
     577,   581,   585,   587,   589,   591,   594,   596,   598,   602,
     604,   606,   608,   610,   612,   615,   617,   619,   622,   625,
     628,   631,   633,   635,   637,   639,   643,   645,   647,   649,
     651,   655,   657,   659,   661,   664,   666,   668,   670,   672,
     674,   676,   680,   683,   688,   693,   698,   703,   708,   713,
     718,   723,   728,   733,   738,   743,   748,   753,   758,   761,
     765,   770,   775,   781,   787,   794,   801,   809,   812,   816,
     821,   826,   832,   838,   843,   846,   850,   855,   860,   866,
     872,   877,   879,   882,   885,   890,   895,   900,   905,   910,
     915,   920,   925,   930,   935,   940,   945,   950,   955,   960,
     963,   967,   972,   977,   983,   989,   996,  1003,  1011,  1014,
    1018,  1023,  1028,  1034,  1040,  1045,  1046,  1053,  1056,  1060,
    1065,  1070,  1076,  1082,  1087,  1088,  1095,  1097,  1099,  1101,
    1105,  1107,  1109,  1111,  1113,  1117,  1121,  1123,  1127,  1131,
    1133,  1137,  1141,  1143,  1147,  1151,  1153,  1155,  1157,  1159,
    1161,  1163,  1165,  1167,  1169,  1171,  1173,  1175,  1178,  1180,
    1182,  1184,  1186,  1188,  1191,  1193,  1195,  1197,  1199,  1201,
    1203,  1205,  1207,  1209,  1211,  1213,  1215,  1217,  1219,  1221,
    1223,  1225,  1227,  1229,  1231,  1233,  1235,  1237,  1239,  1241,
    1243,  1245,  1247,  1249,  1251,  1253,  1255,  1257,  1259,  1260,
    1261,  1265,  1269,  1273,  1277,  1281,  1285,  1289,  1293,  1297,
    1301
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
      81,     0,    -1,    -1,    82,    83,    -1,    -1,    83,    84,
      52,    -1,    83,    86,    52,    -1,    83,    88,    -1,    83,
      89,    -1,    83,   113,    -1,    83,   120,    -1,    83,    51,
      -1,    83,     1,    52,    -1,    11,    85,    -1,    84,    53,
      85,    -1,    37,    -1,    37,     4,    37,    -1,    12,    87,
      -1,    86,    53,    87,    -1,    37,    -1,    37,     4,    37,
      -1,    54,    38,    -1,    54,    55,    38,    -1,    54,    56,
      38,    -1,    -1,   101,    90,   106,    52,    -1,    21,   204,
      95,    52,    -1,   103,    21,   204,    95,    52,    -1,    21,
     203,    31,   202,    52,    -1,   103,    21,   203,    31,   202,
      52,    -1,    -1,    21,   203,    96,    91,    97,    52,    -1,
      -1,   103,    21,   203,    96,    92,    97,    52,    -1,    -1,
       9,    21,   203,    96,    93,    52,    -1,    -1,   103,     9,
      21,   203,    96,    94,    52,    -1,    -1,     4,   203,    -1,
      -1,    57,   202,    -1,    -1,    58,    98,    -1,    99,    -1,
      98,    59,    99,    -1,    -1,   100,   102,   106,    -1,   103,
      -1,   104,    -1,   103,   104,    -1,    -1,   101,    -1,    17,
      -1,    18,    -1,   105,    -1,   104,   105,    -1,     5,    -1,
      19,    -1,     9,    -1,    23,    -1,   108,    -1,    -1,   106,
      53,   107,   108,    -1,    -1,   189,    58,   109,   137,    -1,
     189,   110,    -1,    60,   200,    61,   110,   111,    -1,   190,
     110,   112,    -1,    60,   201,    61,   110,   111,   112,    -1,
      -1,   110,    33,    -1,   110,    62,    33,    -1,    -1,    54,
      38,    -1,    54,    60,   187,    61,    -1,    -1,     4,   189,
      -1,     6,   114,    52,    -1,    22,   118,    52,    -1,   115,
      -1,   114,    53,   115,    -1,    -1,    -1,   116,   131,    58,
     117,   137,    -1,   119,    -1,   118,    53,   119,    -1,   188,
      -1,    -1,   131,   121,    58,   122,    -1,    -1,   123,   137,
     125,    52,    -1,    -1,   122,    58,   124,   137,   125,    52,
      -1,    -1,   125,   126,    -1,   125,   127,    -1,    10,   156,
      -1,    16,    -1,    -1,    24,   128,   129,    -1,   130,    -1,
     129,    53,   130,    -1,   131,    58,   137,    -1,   133,    -1,
      63,   132,    -1,   177,    64,   131,    -1,   177,   132,    -1,
     134,    -1,   133,   159,   134,    -1,   135,    -1,    10,   148,
      20,   134,     8,   134,    -1,    10,   148,    20,   134,    -1,
     136,    -1,   136,   162,   135,    -1,   150,    -1,   150,   143,
     150,    -1,   139,    -1,    63,   138,    -1,   178,    64,   137,
      -1,   178,   138,    -1,   140,    -1,   139,   159,   140,    -1,
     141,    -1,    10,   161,    20,   140,     8,   140,    -1,    10,
     161,    20,   140,    -1,   142,    -1,   142,   162,   141,    -1,
     165,    -1,   165,   143,   165,    -1,    65,    -1,    66,    -1,
      28,    -1,    29,    -1,    30,    -1,    42,    -1,   146,    -1,
      63,   145,    -1,   177,    64,   144,    -1,   177,   145,    -1,
     147,    -1,   146,   159,   147,    -1,   148,    -1,    10,   148,
      20,   147,     8,   147,    -1,    10,   148,    20,   147,    -1,
     149,    -1,   149,   162,   148,    -1,   150,    -1,   150,   164,
     150,    -1,   151,    -1,   150,   166,   151,    -1,   150,    56,
     151,    -1,   152,    -1,   151,   168,   152,    -1,   153,    -1,
      56,    38,    -1,    56,    39,    -1,    56,   152,    -1,   170,
     152,    -1,   154,    -1,   154,   172,   153,    -1,   155,    -1,
     154,   174,   155,    -1,   177,    -1,   155,   177,    -1,   158,
      -1,    63,   157,    -1,   178,    64,   156,    -1,   178,   157,
      -1,   160,    -1,   158,   159,   160,    -1,    27,    -1,    40,
      -1,   161,    -1,    10,   161,    20,   160,     8,   160,    -1,
      10,   161,    20,   160,    -1,   163,    -1,   163,   162,   161,
      -1,    67,    -1,    41,    -1,   165,    -1,   165,   164,   165,
      -1,    65,    -1,    66,    -1,    58,    -1,    28,    -1,    29,
      -1,    30,    -1,    42,    -1,   167,    -1,   165,   166,   167,
      -1,   165,    56,   167,    -1,    55,    -1,    26,    -1,    15,
      -1,    15,     8,    -1,    43,    -1,   169,    -1,   167,   168,
     169,    -1,    68,    -1,    69,    -1,     7,    -1,    13,    -1,
       3,    -1,     3,    20,    -1,    44,    -1,   171,    -1,    56,
      38,    -1,    56,    39,    -1,    56,   169,    -1,   170,   169,
      -1,    70,    -1,    14,    -1,    45,    -1,   173,    -1,   173,
     172,   171,    -1,    71,    -1,    72,    -1,    46,    -1,   175,
      -1,   173,   174,   175,    -1,    64,    -1,    47,    -1,   178,
      -1,   175,   178,    -1,    73,    -1,    74,    -1,    62,    -1,
      75,    -1,    49,    -1,   181,    -1,   194,    57,   202,    -1,
     176,   177,    -1,    60,   146,   159,    61,    -1,    60,   159,
     148,    61,    -1,    60,   149,   162,    61,    -1,    60,   162,
     148,    61,    -1,    60,   150,   164,    61,    -1,    60,   164,
     150,    61,    -1,    60,   150,   166,    61,    -1,    60,   150,
      56,    61,    -1,    60,   166,   151,    61,    -1,    60,   151,
     168,    61,    -1,    60,   168,   152,    61,    -1,    60,   154,
     172,    61,    -1,    60,   172,   153,    61,    -1,    60,   154,
     174,    61,    -1,    60,   174,   155,    61,    -1,    60,    61,
      -1,    60,   144,    61,    -1,    60,   144,    53,    61,    -1,
      60,   144,    52,    61,    -1,    60,   144,    59,   144,    61,
      -1,    60,   144,    53,   182,    61,    -1,    60,   144,    53,
     182,    53,    61,    -1,    60,   144,    53,   182,    52,    61,
      -1,    60,   144,    53,   182,    59,   144,    61,    -1,    76,
      77,    -1,    76,   183,    77,    -1,    76,   183,    53,    77,
      -1,    76,   183,    52,    77,    -1,    76,   183,    59,   144,
      77,    -1,    76,   183,    25,   144,    77,    -1,    76,   183,
      25,    77,    -1,    78,    79,    -1,    78,   183,    79,    -1,
      78,   183,    53,    79,    -1,    78,   183,    52,    79,    -1,
      78,   183,    59,   144,    79,    -1,    78,   183,    25,   144,
      79,    -1,    78,   183,    25,    79,    -1,   181,    -1,    23,
     189,    -1,   176,   178,    -1,    60,   158,   159,    61,    -1,
      60,   159,   161,    61,    -1,    60,   163,   162,    61,    -1,
      60,   162,   161,    61,    -1,    60,   165,   164,    61,    -1,
      60,   164,   165,    61,    -1,    60,   165,   166,    61,    -1,
      60,   165,    56,    61,    -1,    60,   166,   167,    61,    -1,
      60,   167,   168,    61,    -1,    60,   168,   169,    61,    -1,
      60,   173,   172,    61,    -1,    60,   172,   171,    61,    -1,
      60,   173,   174,    61,    -1,    60,   174,   175,    61,    -1,
      60,    61,    -1,    60,   156,    61,    -1,    60,   156,    53,
      61,    -1,    60,   156,    52,    61,    -1,    60,   156,    59,
     156,    61,    -1,    60,   156,    53,   184,    61,    -1,    60,
     156,    53,   184,    53,    61,    -1,    60,   156,    53,   184,
      52,    61,    -1,    60,   156,    53,   184,    59,   156,    61,
      -1,    76,    77,    -1,    76,   185,    77,    -1,    76,   185,
      53,    77,    -1,    76,   185,    52,    77,    -1,    76,   185,
      59,   156,    77,    -1,    76,   185,    25,   156,    77,    -1,
      76,   185,    25,    77,    -1,    -1,    76,   156,    57,   179,
     185,    77,    -1,    78,    79,    -1,    78,   185,    79,    -1,
      78,   185,    53,    79,    -1,    78,   185,    52,    79,    -1,
      78,   185,    59,   156,    79,    -1,    78,   185,    25,   156,
      79,    -1,    78,   185,    25,    79,    -1,    -1,    78,   156,
      57,   180,   185,    79,    -1,    38,    -1,    39,    -1,    32,
      -1,    60,   187,    61,    -1,   191,    -1,   197,    -1,   194,
      -1,   144,    -1,   182,    53,   144,    -1,   182,    52,   144,
      -1,   144,    -1,   183,    53,   144,    -1,   183,    52,   144,
      -1,   156,    -1,   184,    53,   156,    -1,   184,    52,   156,
      -1,   156,    -1,   185,    53,   156,    -1,   185,    52,   156,
      -1,    27,    -1,    67,    -1,    65,    -1,    66,    -1,    58,
      -1,    28,    -1,    29,    -1,    30,    -1,    26,    -1,    55,
      -1,    56,    -1,    15,    -1,    15,     8,    -1,    68,    -1,
      69,    -1,     7,    -1,    13,    -1,     3,    -1,     3,    20,
      -1,    70,    -1,    14,    -1,    73,    -1,    74,    -1,    62,
      -1,    75,    -1,    71,    -1,    72,    -1,    64,    -1,   186,
      -1,    40,    -1,    41,    -1,    42,    -1,    43,    -1,    44,
      -1,    45,    -1,    46,    -1,    47,    -1,    49,    -1,   191,
      -1,   195,    -1,   192,    -1,   196,    -1,   193,    -1,   197,
      -1,    34,    -1,    36,    -1,    34,    -1,    36,    -1,    33,
      -1,    33,    -1,    35,    -1,    33,    -1,    35,    -1,    -1,
      -1,   198,   192,   199,    -1,   198,   193,   199,    -1,   198,
     186,   199,    -1,   198,    33,   199,    -1,   198,    34,   199,
      -1,   198,    35,   199,    -1,   198,    36,   199,    -1,   198,
      33,   199,    -1,   198,    34,   199,    -1,   198,    35,   199,
      -1,   198,    36,   199,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   112,   112,   112,   116,   117,   119,   121,   123,   125,
     127,   129,   136,   140,   141,   144,   146,   150,   151,   154,
     156,   160,   162,   164,   170,   169,   172,   178,   184,   188,
     193,   192,   210,   209,   226,   225,   230,   229,   236,   237,
     242,   243,   247,   248,   251,   252,   255,   255,   259,   260,
     261,   264,   265,   268,   270,   274,   275,   278,   280,   282,
     284,   288,   289,   289,   292,   292,   308,   324,   338,   359,
     380,   381,   390,   399,   400,   402,   414,   415,   419,   420,
     423,   424,   427,   429,   427,   434,   435,   438,   451,   450,
     455,   455,   459,   458,   464,   465,   467,   470,   472,   477,
     476,   482,   483,   486,   492,   493,   496,   498,   502,   503,
     507,   508,   516,   526,   527,   531,   532,   536,   537,   540,
     542,   546,   547,   551,   552,   560,   570,   571,   575,   576,
     580,   581,   582,   583,   584,   585,   591,   592,   595,   597,
     601,   602,   606,   607,   615,   625,   626,   630,   631,   635,
     636,   638,   642,   643,   649,   650,   651,   652,   653,   655,
     656,   660,   661,   665,   666,   670,   671,   674,   676,   680,
     681,   685,   686,   689,   690,   698,   708,   709,   713,   714,
     717,   718,   722,   723,   724,   725,   726,   727,   728,   731,
     732,   734,   738,   739,   740,   741,   742,   745,   746,   750,
     751,   752,   753,   754,   755,   756,   761,   762,   763,   764,
     765,   768,   769,   770,   773,   774,   778,   779,   780,   783,
     784,   788,   789,   792,   793,   797,   798,   799,   800,   801,
     806,   808,   813,   818,   821,   826,   829,   834,   837,   842,
     845,   848,   853,   856,   861,   864,   869,   872,   879,   881,
     883,   885,   888,   890,   892,   894,   897,   902,   904,   907,
     910,   914,   916,   920,   926,   928,   931,   934,   938,   940,
     944,   953,   957,   966,   971,   974,   979,   982,   987,   990,
     995,   998,  1001,  1006,  1009,  1014,  1017,  1022,  1025,  1032,
    1034,  1036,  1038,  1041,  1043,  1045,  1047,  1050,  1055,  1057,
    1060,  1063,  1067,  1069,  1073,  1077,  1076,  1090,  1092,  1095,
    1098,  1102,  1104,  1108,  1112,  1111,  1130,  1131,  1132,  1136,
    1137,  1138,  1139,  1143,  1146,  1148,  1152,  1154,  1156,  1160,
    1163,  1165,  1169,  1171,  1173,  1177,  1178,  1179,  1180,  1181,
    1182,  1183,  1184,  1185,  1186,  1187,  1188,  1189,  1190,  1191,
    1192,  1193,  1194,  1195,  1196,  1197,  1198,  1199,  1200,  1201,
    1202,  1203,  1204,  1207,  1208,  1209,  1210,  1211,  1212,  1213,
    1214,  1215,  1216,  1219,  1220,  1223,  1224,  1227,  1228,  1231,
    1233,  1237,  1241,  1245,  1249,  1251,  1255,  1259,  1263,  1266,
    1269,  1273,  1275,  1279,  1281,  1283,  1285,  1289,  1291,  1295,
    1297
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "AND", "AS", "CONST", "DEF", "DIV",
  "ELSE", "EXTERN", "IF", "IMPORT", "INCLUDE", "MOD", "NOT", "OR",
  "OTHERWISE", "PRIVATE", "PUBLIC", "SPECIAL", "THEN", "TYPE", "UNDEF",
  "VAR", "WHERE", "DOTDOT", "CAT", "DBAR", "LEQ", "GEQ", "NEQ", "EQUIV",
  "STR", "UID", "LID", "QUID", "QLID", "STR1", "INT", "FLOAT", "OP0",
  "OP1", "OP2", "OP3", "OP4", "OP5", "OP6", "OP7", "OP8", "OP9", "ERRTOK",
  "EOFTOK", "';'", "','", "'@'", "'+'", "'-'", "':'", "'='", "'|'", "'('",
  "')'", "'~'", "'\\\\'", "'.'", "'<'", "'>'", "'$'", "'*'", "'/'", "'#'",
  "'^'", "'!'", "'''", "'`'", "'&'", "'['", "']'", "'{'", "'}'", "$accept",
  "source", "@1", "program", "imports", "import", "includes", "include",
  "priority", "declaration", "@2", "@3", "@4", "@5", "@6", "type_alias",
  "opt_type", "opt_header_sects", "header_sects", "header_sect", "@7",
  "prefix", "opt_prefix", "scope", "modifiers", "modifier", "headers",
  "@8", "header", "@9", "vid_list", "id_prec", "id_alias", "definition",
  "defs", "def", "@10", "@11", "undefs", "undef", "rule", "@12", "body",
  "@13", "@14", "qualifiers", "condition", "where", "@15", "where_clauses",
  "where_clause", "lexpression0", "llambda0", "lsequence0", "lcond0",
  "lrightapp0", "lrelation0", "expression0", "lambda0", "sequence0",
  "cond0", "rightapp0", "relation0", "relop0", "lexpression", "llambda",
  "lsequence", "lcond", "lrightapp", "lrelation", "laddition",
  "lmultiplication", "lunary", "lscript", "lcomposition", "lapplication",
  "expression", "lambda", "sequence", "seqop", "cond", "rightapp",
  "rappop", "relation", "relop", "addition", "addop", "multiplication",
  "mulop", "unary", "unop", "script", "scriptop", "composition", "compop",
  "application", "quoteop", "lprimary", "primary", "@16", "@17", "atom",
  "lexpr_list1", "lexpr_list", "expr_list1", "expr_list", "builtin_op",
  "op", "id", "nid", "qid", "fid", "nfid", "qfid", "vid", "fvid", "nfvid",
  "qfvid", "c_on", "c_off", "nfid_or_op", "qfid_or_op", "tid", "ntid",
  "qtid", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,    59,    44,    64,    43,    45,    58,    61,   124,
      40,    41,   126,    92,    46,    60,    62,    36,    42,    47,
      35,    94,    33,    39,    96,    38,    91,    93,   123,   125
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    80,    82,    81,    83,    83,    83,    83,    83,    83,
      83,    83,    83,    84,    84,    85,    85,    86,    86,    87,
      87,    88,    88,    88,    90,    89,    89,    89,    89,    89,
      91,    89,    92,    89,    93,    89,    94,    89,    95,    95,
      96,    96,    97,    97,    98,    98,   100,    99,   101,   101,
     101,   102,   102,   103,   103,   104,   104,   105,   105,   105,
     105,   106,   107,   106,   109,   108,   108,   108,   108,   108,
     110,   110,   110,   111,   111,   111,   112,   112,   113,   113,
     114,   114,   116,   117,   115,   118,   118,   119,   121,   120,
     123,   122,   124,   122,   125,   125,   125,   126,   126,   128,
     127,   129,   129,   130,   131,   131,   132,   132,   133,   133,
     134,   134,   134,   135,   135,   136,   136,   137,   137,   138,
     138,   139,   139,   140,   140,   140,   141,   141,   142,   142,
     143,   143,   143,   143,   143,   143,   144,   144,   145,   145,
     146,   146,   147,   147,   147,   148,   148,   149,   149,   150,
     150,   150,   151,   151,   152,   152,   152,   152,   152,   153,
     153,   154,   154,   155,   155,   156,   156,   157,   157,   158,
     158,   159,   159,   160,   160,   160,   161,   161,   162,   162,
     163,   163,   164,   164,   164,   164,   164,   164,   164,   165,
     165,   165,   166,   166,   166,   166,   166,   167,   167,   168,
     168,   168,   168,   168,   168,   168,   169,   169,   169,   169,
     169,   170,   170,   170,   171,   171,   172,   172,   172,   173,
     173,   174,   174,   175,   175,   176,   176,   176,   176,   176,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   177,   177,   177,   177,   177,   177,   177,   177,   177,
     177,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   178,   178,   178,   178,   178,
     178,   178,   178,   178,   178,   179,   178,   178,   178,   178,
     178,   178,   178,   178,   180,   178,   181,   181,   181,   181,
     181,   181,   181,   182,   182,   182,   183,   183,   183,   184,
     184,   184,   185,   185,   185,   186,   186,   186,   186,   186,
     186,   186,   186,   186,   186,   186,   186,   186,   186,   186,
     186,   186,   186,   186,   186,   186,   186,   186,   186,   186,
     186,   186,   186,   187,   187,   187,   187,   187,   187,   187,
     187,   187,   187,   188,   188,   189,   189,   190,   190,   191,
     191,   192,   193,   194,   195,   195,   196,   197,   198,   199,
     200,   201,   201,   202,   202,   202,   202,   203,   203,   204,
     204
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     0,     3,     3,     2,     2,     2,
       2,     2,     3,     2,     3,     1,     3,     2,     3,     1,
       3,     2,     3,     3,     0,     4,     4,     5,     5,     6,
       0,     6,     0,     7,     0,     6,     0,     7,     0,     2,
       0,     2,     0,     2,     1,     3,     0,     3,     1,     1,
       2,     0,     1,     1,     1,     1,     2,     1,     1,     1,
       1,     1,     0,     4,     0,     4,     2,     5,     3,     6,
       0,     2,     3,     0,     2,     4,     0,     2,     3,     3,
       1,     3,     0,     0,     5,     1,     3,     1,     0,     4,
       0,     4,     0,     6,     0,     2,     2,     2,     1,     0,
       3,     1,     3,     3,     1,     2,     3,     2,     1,     3,
       1,     6,     4,     1,     3,     1,     3,     1,     2,     3,
       2,     1,     3,     1,     6,     4,     1,     3,     1,     3,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     2,
       1,     3,     1,     6,     4,     1,     3,     1,     3,     1,
       3,     3,     1,     3,     1,     2,     2,     2,     2,     1,
       3,     1,     3,     1,     2,     1,     2,     3,     2,     1,
       3,     1,     1,     1,     6,     4,     1,     3,     1,     1,
       1,     3,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     3,     1,     1,     1,     2,     1,     1,     3,     1,
       1,     1,     1,     1,     2,     1,     1,     2,     2,     2,
       2,     1,     1,     1,     1,     3,     1,     1,     1,     1,
       3,     1,     1,     1,     2,     1,     1,     1,     1,     1,
       1,     3,     2,     4,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     2,     3,
       4,     4,     5,     5,     6,     6,     7,     2,     3,     4,
       4,     5,     5,     4,     2,     3,     4,     4,     5,     5,
       4,     1,     2,     2,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,     2,
       3,     4,     4,     5,     5,     6,     6,     7,     2,     3,
       4,     4,     5,     5,     4,     0,     6,     2,     3,     4,
       4,     5,     5,     4,     0,     6,     1,     1,     1,     3,
       1,     1,     1,     1,     3,     3,     1,     3,     3,     1,
       3,     3,     1,     3,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     1,
       1,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     0,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short int yydefact[] =
{
       2,     0,     4,     1,     0,     0,    57,    82,    59,     0,
       0,     0,   212,    53,    54,    58,   388,     0,    60,   318,
     383,   379,   387,   380,   316,   317,   213,   229,    11,     0,
       0,     0,   227,     0,   211,   225,   226,   228,     0,     0,
       0,     0,     7,     8,    24,    48,    49,    55,     9,    10,
      88,   104,   108,   110,   113,   115,   149,   152,   154,   159,
     161,     0,     0,   163,   230,   320,   322,   321,    12,     0,
      80,     0,   388,     0,   145,   147,    15,    13,    19,    17,
       0,    40,    38,   384,   385,     0,    85,    87,   373,   374,
      21,     0,     0,   155,   156,   157,   203,   201,     0,   202,
     212,   194,   193,   171,   185,   186,   187,   172,   179,   188,
     196,   205,   213,   218,   222,   229,   192,   345,   184,   248,
     227,     0,   221,   182,   183,   178,   199,   200,   211,   216,
     217,   225,   226,   228,     0,   136,   140,   142,   145,   147,
     149,   159,     0,     0,     0,     0,     0,     0,     0,   363,
       0,   105,     0,   257,   326,   136,     0,   264,     0,     5,
       0,     6,     0,     0,    59,   388,    50,    59,    56,     0,
     171,   172,     0,   179,   178,     0,   194,   193,   132,   133,
     134,   135,   196,   192,     0,   130,   131,     0,     0,   203,
     201,   202,   205,   199,   200,     0,   218,   222,   221,   216,
     217,     0,     0,   164,   158,   232,   388,    78,    82,     0,
       0,    40,     0,     0,   185,   186,   187,   188,   184,   182,
     183,     0,     0,     0,   389,   389,   389,   389,   388,   388,
      30,   388,     0,    79,     0,    22,    23,   204,     0,   195,
     137,     0,     0,     0,     0,   249,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   319,     0,   107,     0,     0,     0,     0,     0,   258,
       0,     0,     0,     0,   265,    14,    18,   386,   381,   382,
     388,     0,    61,    70,    70,   375,   377,   376,   378,   388,
      40,    38,    90,   109,   114,   195,   151,   116,   150,   204,
     153,   160,   162,     0,   231,    81,    83,    34,   112,   146,
     148,    16,    20,   397,   398,   399,   400,     0,    41,    42,
      39,    26,    86,     0,     0,   139,   251,   250,   323,     0,
       0,   233,   141,   235,   240,   237,   239,   242,   244,   246,
     234,   236,   238,   241,   243,   245,   247,   106,   263,     0,
     260,   328,   259,   327,     0,   270,     0,   267,   266,     0,
       0,     0,     0,    25,    62,    64,    66,    76,    40,   388,
      32,     0,    89,     0,   389,   389,   389,   389,     0,     0,
       0,    28,    46,     0,   144,   138,     0,     0,     0,   253,
     252,   262,   261,   269,   268,   352,   350,   351,   355,   346,
     343,   335,   340,   341,   342,   344,   345,   339,   358,   362,
     337,   338,   336,   348,   349,   354,   360,   361,   356,   357,
     359,   389,   389,   389,    70,    70,     0,     0,    71,     0,
       0,    68,    36,     0,    42,    27,    92,     0,     0,     0,
       0,     0,     0,     0,    94,   117,   121,   123,   126,   128,
     189,   197,     0,   206,   214,   219,     0,   223,   271,   322,
     393,   394,   395,   396,    84,    35,   111,    43,    44,    51,
      31,     0,   255,   325,   254,   324,     0,   353,   347,   392,
     390,   391,    73,    73,    63,    65,    72,    77,     0,    29,
       0,     0,     0,   176,   180,   272,   207,   208,   209,     0,
     345,   289,     0,     0,   165,     0,   169,   173,     0,   176,
       0,   180,     0,   189,     0,     0,   214,     0,   118,     0,
     298,   332,   165,     0,   307,   332,     0,     0,     0,     0,
       0,     0,     0,     0,   210,     0,     0,   224,   273,    46,
      52,     0,    48,   143,   256,     0,    67,    76,    37,    33,
      94,     0,     0,     0,     0,   166,     0,     0,     0,     0,
     290,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   120,   305,     0,
       0,     0,     0,     0,   299,   314,     0,     0,     0,     0,
     308,     0,    98,    99,    91,    95,    96,   122,   127,   191,
     129,   190,   198,   215,   220,    45,    47,    74,     0,    69,
       0,   125,   177,   181,     0,     0,   168,   292,   291,   329,
       0,     0,   274,   170,   275,   277,   276,   279,   281,   278,
     280,   282,   283,   284,   286,   285,   287,   288,   119,     0,
     304,     0,   301,   334,   300,   333,     0,     0,   313,     0,
     310,   309,     0,    97,     0,   364,   365,   366,   367,   368,
     369,   370,   371,   372,     0,    93,     0,   175,   167,     0,
       0,     0,   294,   293,   332,     0,   303,   302,     0,   312,
     311,   100,   101,     0,    75,   124,     0,   296,   331,   295,
     330,     0,     0,     0,   306,   315,     0,     0,   174,   297,
     102,   103
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,     4,    40,    77,    41,    79,    42,    43,
     163,   319,   434,   379,   488,   232,   230,   383,   467,   468,
     469,    44,   541,    45,    46,    47,   281,   426,   282,   427,
     366,   546,   431,    48,    69,    70,    71,   378,    85,    86,
      49,   169,   372,   373,   491,   527,   595,   596,   654,   681,
     682,   683,   151,    51,    52,    53,    54,   444,   518,   445,
     446,   447,   448,   187,   154,   240,   155,   136,   137,    74,
      75,    56,    57,    58,    59,    60,   643,   555,   522,   142,
     506,   507,   143,   493,   144,   494,   188,   450,   195,   451,
     452,   453,   147,   454,   148,   455,   456,    63,   457,   639,
     647,   458,   329,   156,   620,   523,   149,   150,    87,   283,
     284,    65,   285,   286,   459,    89,   287,    67,   303,   313,
     361,   362,   304,    81,    82
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -532
static const short int yypact[] =
{
    -532,    40,  -532,  -532,   822,    12,  -532,  -532,    63,  3521,
      54,    71,  -532,  -532,  -532,  -532,  -532,   454,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,   248,
    3568,  1140,  -532,  4076,  -532,  -532,  -532,  -532,  2090,  1493,
     129,   163,  -532,  -532,  -532,   409,   435,  -532,  -532,  -532,
    -532,    48,  -532,  -532,    36,  1309,    56,  -532,  -532,   140,
    4076,  3521,  4076,  -532,  -532,  -532,    55,  -532,  -532,   198,
    -532,  2600,  -532,    99,    36,   576,   122,  -532,   131,  -532,
     472,    76,   153,  -532,  -532,   223,  -532,  -532,  -532,  -532,
    -532,   134,   138,  3892,  3911,  -532,    21,   106,  3521,   117,
     124,    24,   128,   144,   158,   164,   167,   173,   196,   216,
     218,   224,   230,   244,   253,   263,   264,  3568,   266,  -532,
     270,  4076,   274,   278,   279,   289,   297,   304,   305,   307,
     312,   317,   318,   325,   277,    48,  -532,  -532,    36,   687,
      56,   140,  3521,  3521,  3521,  3521,  3521,  4076,  4076,  -532,
     326,  -532,  3958,  -532,  -532,    48,   154,  -532,   293,  -532,
      54,  -532,    71,   160,   139,  -532,   435,  -532,  -532,   141,
    -532,  -532,  2839,  -532,  -532,  3521,   301,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  3521,  -532,  -532,  3521,  3521,   324,
    -532,  -532,  -532,  -532,  -532,  3521,  -532,  -532,  -532,  -532,
    -532,  4076,  4076,  -532,  -532,  -532,  -532,  -532,  -532,   330,
      95,   333,  2839,  3521,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,  3521,   354,   369,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,   356,  -532,   454,  -532,  -532,   348,   391,   355,
    -532,  3966,   358,  2137,  2647,  -532,  2694,  3180,  3229,  3278,
    3327,  3376,  4013,  4021,   360,   362,   308,   465,   366,   368,
    4068,  -532,  2600,  -532,  2886,  2191,  2238,  2285,  2647,  -532,
    1544,  1595,  1646,  2647,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,   247,  -532,   359,  -532,  -532,  -532,  -532,  -532,  -532,
     143,   153,  -532,  -532,  -532,  -532,    56,   571,    56,  -532,
    -532,  -532,  4076,   509,  -532,  -532,  -532,  -532,   425,  -532,
     571,  -532,  -532,  -532,  -532,  -532,  -532,   383,  -532,   378,
    -532,  -532,  -532,  2886,  2647,  -532,  -532,  -532,  -532,   511,
     380,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,   365,
    -532,  -532,  -532,  -532,   376,  -532,   364,  -532,  -532,   377,
     911,   398,   399,  -532,  -532,  -532,    59,    39,   333,  -532,
    -532,   387,   408,  2342,  -532,  -532,  -532,  -532,  2342,   427,
    2839,  -532,  -532,   429,   476,  -532,  2389,  2443,  2647,  -532,
    -532,  -532,  -532,  -532,  -532,   475,  -532,  -532,  -532,   477,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,   160,  2342,  -532,   459,
     283,  -532,  -532,   461,   378,  -532,  -532,  3425,   283,  3474,
    1048,  3832,  1700,  1280,  -532,    48,  -532,  -532,    36,  1363,
      56,  -532,  3425,  -532,   140,  3832,  3832,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,   460,  -532,   532,
    -532,  2886,  -532,  -532,  -532,  -532,   463,  -532,  -532,  -532,
    -532,  -532,     6,     6,  -532,  -532,  -532,  -532,   479,  -532,
     486,  2342,   526,    36,  1209,  -532,  3587,  3634,  -532,  3425,
    3474,  -532,  3832,   548,    48,  3425,  -532,  -532,  3425,    36,
    3425,  3857,  3425,    56,  3425,  3832,   140,  3832,  -532,  3653,
    -532,   490,    48,   249,  -532,   491,   322,    26,  2743,  3425,
    3425,  3425,  3425,  3425,  -532,  3832,  3832,  -532,  -532,  -532,
    -532,   160,   435,  -532,  -532,    58,  -532,   525,  -532,  -532,
    -532,  2743,  3425,  3425,   537,  -532,  3700,   497,  1757,  2497,
    -532,  2551,   498,   499,  2935,   602,  2984,  3033,  3082,   467,
    3131,   506,   507,  3719,  3766,  3785,  2342,  -532,  -532,  2792,
    1811,  1868,  1925,  2497,  -532,  -532,  1334,  1388,  1442,  2497,
    -532,  2497,  -532,  -532,  -532,  -532,  -532,  -532,  -532,    56,
     671,    56,  -532,  -532,  3832,  -532,   524,  -532,  1214,  -532,
      37,   568,  -532,   671,  2792,  2497,  -532,  -532,  -532,  -532,
     600,   517,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  -532,  2497,
    -532,   503,  -532,  -532,  -532,  -532,   504,  2497,  -532,   520,
    -532,  -532,   529,  -532,  2600,  -532,  -532,  -532,  -532,  -532,
    -532,  -532,  -532,  -532,   521,  -532,  2743,   595,  -532,  1982,
    2036,  2497,  -532,  -532,  -532,   150,  -532,  -532,    70,  -532,
    -532,   557,  -532,   553,  -532,  -532,  2792,  -532,  -532,  -532,
    -532,   551,  2497,  2497,  -532,  -532,  2600,  2342,  -532,  -532,
    -532,  -532
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -532,  -532,  -532,  -532,  -532,   453,  -532,   458,  -532,  -532,
    -532,  -532,  -532,  -532,  -532,   332,  -191,   181,  -532,    77,
    -532,   155,  -532,   156,   -38,   -13,    88,  -532,   207,  -532,
    -263,   165,    92,  -532,  -532,   439,  -532,  -532,  -532,   401,
    -532,  -532,  -532,  -532,  -532,   101,  -532,  -532,  -532,  -532,
     -47,    10,   508,  -532,  -157,   480,  -532,  -375,   137,  -532,
    -497,   135,  -532,   225,    89,   431,   642,  -236,     8,   648,
      66,   -18,    19,  -122,   651,   -97,     7,   132,   245,   -40,
    -531,  -215,   -36,   251,   -63,   152,   -25,  -378,   -30,  -341,
     777,  -469,   -55,   254,   -51,  -443,    -4,    11,  -149,  -532,
    -532,   250,  -532,   645,  -532,  -421,   327,    81,  -532,  -393,
    -532,     2,   336,   339,   523,  -532,  -532,  -161,    -7,   -80,
    -532,  -532,  -205,   -56,   528
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -373
static const short int yytable[] =
{
      62,   146,   288,   464,   201,    62,   145,   166,   202,    80,
     332,   172,   221,   140,    50,   293,   211,    73,   175,    88,
     307,   367,   526,   317,   318,   259,    62,    62,   332,    62,
     623,   597,   239,   168,    62,    62,   591,   487,   213,   428,
       3,   237,   592,   430,   152,   495,   572,   591,   623,    95,
     593,   260,   485,   592,   611,   308,    62,    62,    62,   189,
     545,   593,   513,   190,    68,   210,   603,    62,   429,   191,
      55,   203,   428,   205,   575,   170,   249,   173,   594,   301,
     204,   209,  -352,   667,    72,  -346,   252,   384,   171,   665,
     253,    76,   428,   604,    62,   246,   607,   139,   498,   370,
     192,   429,   247,   174,   603,   302,   238,   228,    78,   290,
     251,   534,   206,    62,   250,   264,   550,    62,   608,   212,
     134,   429,   692,   693,   193,   194,   222,   257,   224,   225,
     301,   604,   241,   229,   569,   223,    95,    55,    62,    62,
      62,    62,    62,    62,    62,   314,   315,   316,    62,   695,
     254,   255,   599,   168,   601,   698,   302,   231,    80,   498,
     289,   482,   483,   152,   433,   258,   296,  -350,    62,   685,
     298,    62,   235,   571,   369,   320,   236,   432,  -351,   265,
      62,   159,   160,    62,    62,  -355,   196,   197,   599,  -343,
     601,    62,   602,   277,   278,    22,   279,    62,    62,   292,
     229,   638,   692,   693,   198,  -335,   266,   267,    62,    62,
     256,   199,   200,   268,   300,   161,   162,    62,   675,  -340,
     280,   309,   492,   466,   210,  -341,   678,   694,  -342,   602,
     296,   269,   298,   368,  -364,   543,    88,    62,    55,    62,
      62,    55,    62,    62,    62,    62,    62,    62,    62,    62,
     207,   208,   241,   297,    64,   309,    62,  -365,    62,    64,
      62,    62,    62,    62,    62,   288,    62,    62,    62,    62,
     300,   203,   347,   360,   580,   233,   234,  -366,    55,  -367,
      64,    64,   210,    64,   554,  -368,    90,   310,    64,    64,
     562,  -369,   519,   563,   460,   461,   462,   463,    62,   363,
     364,   581,   582,    91,    92,  -370,   537,   538,   583,   295,
      64,    64,    64,   203,  -371,   310,   277,   278,   270,    62,
      62,    64,   701,   176,  -372,  -344,   584,  -339,    55,   242,
     243,  -358,   328,   330,   177,  -362,   244,   612,   245,  -337,
    -338,   479,   480,   481,   299,   271,   272,   586,    64,   612,
    -336,   182,   273,   556,   349,   351,   353,   354,  -348,   356,
     351,   353,   359,   183,   184,  -349,  -354,    64,  -360,   342,
     519,    64,   274,  -361,   587,   588,    62,   510,  -356,  -357,
     288,   589,    62,    62,    62,   515,  -359,   261,   306,   517,
     229,   311,    64,    64,    64,    64,    64,    64,    64,   535,
     505,   590,    64,   536,   508,   528,   312,   556,   321,  -353,
     514,   323,   529,   385,     6,   512,  -347,   365,   164,   326,
     533,   340,    64,   341,   532,    64,   537,   344,    15,   345,
     165,   553,    18,   380,    64,   381,   382,    64,    64,   435,
       6,   390,   391,   393,   167,    64,    55,   503,   567,   521,
     525,    64,    64,   392,    15,   537,   394,   552,    18,   424,
     425,   573,    64,    64,   561,   574,   436,    62,   189,   532,
     189,    64,   190,   564,   190,   473,   475,   476,   191,   465,
     191,   470,   579,   570,   471,   478,   568,    83,    21,    84,
      23,    64,   486,    64,    64,   477,    64,    64,    64,    64,
      64,    64,    64,    64,   166,   224,   225,   226,   227,   192,
      64,   192,    64,   489,    64,    64,    64,    64,    64,   539,
      64,    64,    64,    64,   544,   449,   343,    66,   631,   430,
     449,   548,    66,   193,   194,   193,   194,     6,   549,   533,
     532,   167,   374,   375,   376,   377,   551,   578,   585,    13,
      14,    15,    64,    66,    66,    18,    66,   614,   617,   624,
     625,    66,    66,   386,   387,   619,   621,   633,   634,   533,
     388,   533,   389,    64,    64,   532,   666,   364,   673,   449,
     676,   677,   684,    66,    66,    66,   176,   641,   532,   645,
     646,   176,   511,   649,    66,   645,   652,   177,   653,   679,
     557,   558,   177,   686,   214,   215,   216,   559,   680,   560,
     696,   697,   699,   275,   182,   490,   605,   176,   217,   182,
     276,    66,   668,   371,   540,   542,   183,   184,   177,   606,
      64,   183,   184,   484,   218,   322,    64,    64,    64,   609,
      66,   219,   220,   449,    66,   182,   674,   305,   547,   700,
      62,   610,   669,   670,   674,   294,   577,   183,   530,   671,
     263,   672,   565,   627,   598,    66,    66,    66,    66,    66,
      66,    66,   325,   135,   531,    66,   688,   690,   691,   138,
     449,   449,   141,   600,   158,   504,   176,   421,   616,   664,
       0,   509,    62,   291,   516,    66,   422,   177,    66,   423,
     645,     0,   176,   449,     0,   613,     0,    66,     0,     0,
      66,    66,     0,   177,   182,   214,   215,   216,    66,   613,
      55,    64,     0,     0,    66,    66,   183,   530,   449,   217,
     182,     0,     0,     0,     0,    66,    66,     0,     0,     0,
       0,     0,   183,   248,    66,   218,     0,     0,     0,     0,
       0,     0,   219,   220,     0,     0,     0,     0,     0,     0,
       0,     0,    55,     0,    66,     0,    66,    66,     0,    66,
      66,    66,    66,    66,    66,    66,    66,     0,     0,     0,
       0,    61,     0,    66,     0,    66,    61,    66,    66,    66,
      66,    66,     0,    66,    66,    66,    66,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    61,    61,     0,
       0,     0,     0,     0,     0,    61,    61,     0,   449,     0,
       0,     0,    -3,     5,     0,    66,     0,     6,     7,     0,
       0,     8,     9,    10,    11,     0,    12,     0,    61,    13,
      14,    15,     0,    16,    17,    18,    66,    66,    61,   449,
       0,     0,     0,     0,    19,    20,    21,    22,    23,     0,
      24,    25,     0,     0,     0,     0,     0,    26,     0,     0,
       0,    27,     0,    28,     0,    61,    29,     0,    30,     0,
       0,     0,    31,     0,    32,    33,     0,     0,     0,     0,
       0,     0,    34,     0,    61,    35,    36,    37,    38,     0,
      39,     0,     0,    66,    64,     0,     0,     0,     0,    66,
      66,    66,     0,     0,   395,     0,     0,     0,   396,    61,
      61,    61,    61,    61,   397,   398,   399,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   400,   401,   402,
     403,   404,     0,     0,     0,   278,    64,   279,     0,    61,
       0,     0,    61,     0,     0,     0,     0,     0,     0,     0,
       0,    61,     0,     0,    61,    61,   405,   406,     0,   407,
       0,     0,    61,   408,     0,   409,   410,   411,   412,   413,
     414,   415,   416,   417,   418,   419,   420,     0,     0,    61,
      61,     0,     0,     0,    66,     0,     0,     0,    61,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      61,    61,     0,    61,    61,    61,    61,    61,    61,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    61,
       0,    61,    61,    61,    61,    61,     0,    61,    61,    61,
      61,    96,     0,     0,     0,    97,     0,     0,   499,     0,
       0,    99,   100,   101,     0,     0,     0,     0,     0,     0,
       0,   438,     0,     0,   102,   103,   104,   105,   106,     0,
      19,    20,    21,    22,    23,     0,    24,    25,   107,   108,
     109,   110,   111,   112,   113,   114,     0,   115,     0,     0,
      61,    61,     0,   116,   500,     0,   118,     0,   440,   501,
     120,   502,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   442,     0,   443,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    96,     0,     0,     0,    97,     0,     0,
      98,     0,     0,    99,   100,   101,     0,    61,     0,     0,
       0,     0,     0,    61,    61,    61,   102,   103,   104,   105,
     106,     0,    19,    20,    21,    22,    23,    66,    24,    25,
     107,   108,   109,   110,   111,   112,   113,   114,     0,   115,
       0,     0,     0,     0,     0,   116,   117,     0,   118,     0,
      31,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,    38,   395,    39,    66,
       0,   396,     0,     0,   176,     0,     0,   397,   398,   399,
       0,     0,     0,     0,     0,   177,     0,   214,   215,   216,
     400,   401,   402,   403,   404,     0,     0,     0,    61,     0,
       0,   217,   182,     0,   655,   656,   657,   658,   659,   660,
     661,   662,     0,   663,   183,   530,     0,   218,     0,   405,
     406,     0,   407,     0,   219,   220,   408,     0,   409,   410,
     411,   412,   413,   414,   415,   416,   417,   418,   419,   420,
     499,     0,     0,     0,    12,     0,     0,     0,     0,     0,
       0,     0,     0,   438,     0,     0,     0,     0,     0,     0,
       0,     0,    19,    20,    21,    22,    23,     0,    24,    25,
       0,     0,     0,     0,   176,    26,     0,     0,     0,    27,
       0,     0,     0,     0,     0,   177,   439,   178,   179,   180,
     440,     0,    32,   502,   499,     0,     0,     0,    12,     0,
      34,   181,   182,    35,    36,    37,   442,   438,   443,   524,
       0,     0,     0,     0,   183,   184,    19,    20,    21,    22,
      23,     0,    24,    25,   185,   186,     0,     0,   176,    26,
       0,     0,     0,    27,     0,     0,     0,     0,     0,   177,
     439,   178,   179,   180,   440,     0,    32,   502,   499,     0,
       0,     0,    12,     0,    34,   181,   182,    35,    36,    37,
     442,   438,   443,   648,     0,     0,     0,     0,   183,   530,
      19,    20,    21,    22,    23,     0,    24,    25,   185,   186,
       0,    61,     0,    26,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,   439,     0,     0,     0,   440,     0,
      32,   502,   499,     0,     0,     0,    12,     0,    34,     0,
       0,    35,    36,    37,   442,   438,   443,   650,     0,     0,
       0,     0,     0,    61,    19,    20,    21,    22,    23,     0,
      24,    25,     0,     0,     0,     0,     0,    26,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,   439,     0,
       0,     0,   440,    98,    32,   502,     0,    12,     0,     0,
       0,     0,    34,     0,     0,    35,    36,    37,   442,     0,
     443,   651,     0,     0,     0,    19,    20,    21,    22,    23,
       0,    24,    25,     0,     0,     0,     0,     0,    26,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,    30,
       0,     0,     0,    31,    98,    32,   121,     0,    12,     0,
       0,     0,     0,    34,     0,     0,    35,    36,    37,    38,
       0,    39,   157,     0,     0,     0,    19,    20,    21,    22,
      23,     0,    24,    25,     0,     0,     0,     0,     0,    26,
       0,     0,     0,    27,     0,     0,     0,     0,     0,     0,
      30,     0,     0,     0,    31,    98,    32,   121,     0,    12,
       0,     0,     0,     0,    34,     0,     0,    35,    36,    37,
      38,     0,    39,   355,     0,     0,     0,    19,    20,    21,
      22,    23,     0,    24,    25,     0,     0,     0,     0,     0,
      26,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,    31,    98,    32,   121,     0,
      12,     0,     0,     0,     0,    34,     0,     0,    35,    36,
      37,    38,     0,    39,   357,     0,     0,     0,    19,    20,
      21,    22,    23,     0,    24,    25,     0,     0,     0,     0,
       0,    26,     0,     0,     0,    27,     0,     0,     0,     0,
       0,     0,    30,     0,     0,     0,    31,     0,    32,   121,
     499,     0,     0,     0,    12,     0,    34,     0,     0,    35,
      36,    37,    38,   438,    39,   358,     0,     0,     0,     0,
       0,     0,    19,    20,    21,    22,    23,     0,    24,    25,
       0,     0,     0,     0,     0,    26,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,   439,     0,     0,     0,
     440,     0,    32,   502,     0,     0,     0,   499,     0,     0,
      34,    12,     0,    35,    36,    37,   442,   520,   443,     0,
     438,     0,     0,     0,     0,     0,     0,     0,     0,    19,
      20,    21,    22,    23,     0,    24,    25,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,   439,     0,     0,     0,   440,   618,    32,
     502,   499,     0,     0,     0,    12,     0,    34,     0,     0,
      35,    36,    37,   442,   438,   443,     0,     0,     0,     0,
       0,     0,     0,    19,    20,    21,    22,    23,     0,    24,
      25,     0,     0,     0,     0,     0,    26,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,   439,     0,     0,
       0,   440,     0,    32,   502,     0,     0,     0,   499,     0,
       0,    34,    12,     0,    35,    36,    37,   442,   640,   443,
       0,   438,     0,     0,     0,     0,     0,     0,     0,     0,
      19,    20,    21,    22,    23,     0,    24,    25,     0,     0,
       0,     0,     0,    26,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,   439,     0,     0,     0,   440,     0,
      32,   502,     0,     0,     0,   499,     0,     0,    34,    12,
       0,    35,    36,    37,   442,   642,   443,     0,   438,     0,
       0,     0,     0,     0,     0,     0,     0,    19,    20,    21,
      22,    23,     0,    24,    25,     0,     0,     0,     0,     0,
      26,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,   439,     0,     0,     0,   440,     0,    32,   502,     0,
       0,     0,   499,     0,     0,    34,    12,     0,    35,    36,
      37,   442,   644,   443,     0,   438,     0,     0,     0,     0,
       0,     0,     0,     0,    19,    20,    21,    22,    23,     0,
      24,    25,     0,     0,     0,     0,     0,    26,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,   439,     0,
       0,     0,   440,   687,    32,   502,   499,     0,     0,     0,
      12,     0,    34,     0,     0,    35,    36,    37,   442,   438,
     443,     0,     0,     0,     0,     0,     0,     0,    19,    20,
      21,    22,    23,     0,    24,    25,     0,     0,     0,     0,
       0,    26,     0,     0,     0,    27,     0,     0,     0,     0,
       0,     0,   439,     0,     0,     0,   440,   689,    32,   502,
      98,     0,     0,     0,    12,     0,    34,     0,     0,    35,
      36,    37,   442,     0,   443,     0,     0,     0,     0,     0,
       0,     0,    19,    20,    21,    22,    23,     0,    24,    25,
       0,     0,     0,     0,     0,    26,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,    30,    98,     0,     0,
      31,    12,    32,   121,     0,     0,     0,     0,     0,     0,
      34,     0,     0,    35,    36,    37,    38,   153,    39,    19,
      20,    21,    22,    23,     0,    24,    25,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,    31,   327,    32,
     121,    98,     0,     0,     0,    12,     0,    34,     0,     0,
      35,    36,    37,    38,     0,    39,     0,     0,     0,     0,
       0,     0,     0,    19,    20,    21,    22,    23,     0,    24,
      25,     0,     0,     0,     0,     0,    26,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,    30,    98,     0,
       0,    31,    12,    32,   121,     0,     0,     0,     0,     0,
       0,    34,     0,     0,    35,    36,    37,    38,   348,    39,
      19,    20,    21,    22,    23,     0,    24,    25,     0,     0,
       0,     0,     0,    26,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,    30,    98,     0,     0,    31,    12,
      32,   121,     0,     0,     0,     0,     0,     0,    34,     0,
       0,    35,    36,    37,    38,   350,    39,    19,    20,    21,
      22,    23,     0,    24,    25,     0,     0,     0,     0,     0,
      26,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,    30,     0,     0,     0,    31,     0,    32,   121,     0,
       0,     0,   437,     0,     0,    34,    12,     0,    35,    36,
      37,    38,   352,    39,     0,   438,     0,     0,     0,     0,
       0,     0,     0,     0,    19,    20,    21,    22,    23,     0,
      24,    25,     0,     0,     0,     0,     0,    26,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,   439,    98,
       0,     0,   440,    12,    32,   441,     0,     0,     0,     0,
       0,     0,    34,     0,     0,    35,    36,    37,   442,     0,
     443,    19,    20,    21,    22,    23,     0,    24,    25,     0,
       0,     0,     0,     0,    26,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,    30,     0,     0,     0,    31,
     472,    32,   121,    98,     0,     0,     0,    12,     0,    34,
       0,     0,    35,    36,    37,    38,     0,    39,     0,     0,
       0,     0,     0,     0,     0,    19,    20,    21,    22,    23,
       0,    24,    25,     0,     0,     0,     0,     0,    26,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,    30,
       0,     0,     0,    31,   474,    32,   121,   499,     0,     0,
       0,    12,     0,    34,     0,     0,    35,    36,    37,    38,
     438,    39,     0,     0,     0,     0,     0,     0,     0,    19,
      20,    21,    22,    23,     0,    24,    25,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,   439,     0,     0,     0,   440,     0,    32,
     502,   499,     0,     0,     0,    12,     0,    34,     0,     0,
      35,    36,    37,   442,   438,   443,     0,     0,     0,     0,
       0,     0,     0,    19,    20,    21,    22,    23,     0,    24,
      25,     0,     0,     0,     0,     0,    26,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,   439,     0,     0,
       9,   440,   622,    32,    12,     0,     0,     0,     0,     0,
       0,    34,     0,     0,    35,    36,    37,   442,     0,   443,
       0,     0,    19,    20,    21,    22,    23,     0,    24,    25,
       0,     0,     0,     0,     0,    26,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,    30,    98,     0,     0,
      31,    12,    32,    33,     0,     0,     0,     0,     0,     0,
      34,     0,     0,    35,    36,    37,    38,     0,    39,    19,
      20,    21,    22,    23,     0,    24,    25,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,    30,    98,     0,     0,    31,    12,    32,
     121,     0,     0,     0,     0,     0,     0,    34,     0,     0,
      35,    36,    37,    38,     0,    39,    19,    20,    21,    22,
      23,     0,    24,    25,     0,     0,     0,     0,     0,    26,
       0,     0,     0,    27,     0,     0,     0,     0,     0,     0,
      30,     0,     0,   437,    31,   331,    32,    12,     0,     0,
       0,     0,     0,     0,    34,     0,   438,    35,    36,    37,
      38,     0,    39,     0,     0,    19,    20,    21,    22,    23,
       0,    24,    25,     0,     0,     0,     0,     0,    26,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,   439,
       0,     0,   499,   440,     0,    32,    12,     0,     0,     0,
       0,     0,     0,    34,     0,   438,    35,    36,    37,   442,
       0,   443,     0,     0,    19,    20,    21,    22,    23,     0,
      24,    25,     0,     0,     0,     0,     0,    26,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,   439,     9,
       0,     0,   440,    12,    32,     0,     0,     0,     0,     0,
       0,     0,    34,     0,     0,    35,    36,    37,   442,     0,
     443,    19,    20,    21,    22,    23,     0,    24,    25,     0,
       0,     0,     0,     0,    26,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,    30,    98,     0,     0,    31,
      12,    32,     0,     0,     0,     0,     0,     0,     0,    34,
       0,     0,    35,    36,    37,    38,     0,    39,    19,    20,
      21,    22,    23,     0,    24,    25,     0,     0,     0,     0,
       0,    26,     0,     0,     0,    27,     0,     0,     0,     0,
       0,     0,    30,     0,     0,     0,    31,     0,    32,    12,
       0,     0,     0,     0,     0,     0,    34,     0,   438,    35,
      36,    37,    38,     0,    39,     0,     0,    19,    20,    21,
      22,    23,     0,    24,    25,     0,     0,     0,     0,     0,
      26,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,   439,     0,     0,     0,   440,   626,    32,    12,     0,
       0,     0,     0,     0,     0,    34,     0,   438,    35,    36,
      37,   442,     0,   443,     0,     0,    19,    20,    21,    22,
      23,     0,    24,    25,     0,     0,     0,     0,     0,    26,
       0,     0,     0,    27,     0,     0,     0,     0,     0,     0,
     439,     0,     0,     0,   440,   628,    32,    12,     0,     0,
       0,     0,     0,     0,    34,     0,   438,    35,    36,    37,
     442,     0,   443,     0,     0,    19,    20,    21,    22,    23,
       0,    24,    25,     0,     0,     0,     0,     0,    26,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,   439,
       0,     0,     0,   440,   629,    32,    12,     0,     0,     0,
       0,     0,     0,    34,     0,   438,    35,    36,    37,   442,
       0,   443,     0,     0,    19,    20,    21,    22,    23,     0,
      24,    25,     0,     0,     0,     0,     0,    26,     0,     0,
       0,    27,     0,     0,     0,     0,     0,     0,   439,     0,
       0,     0,   440,   630,    32,    12,     0,     0,     0,     0,
       0,     0,    34,     0,   438,    35,    36,    37,   442,     0,
     443,     0,     0,    19,    20,    21,    22,    23,     0,    24,
      25,     0,     0,     0,     0,     0,    26,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,   439,     0,     0,
       0,   440,   632,    32,    12,     0,     0,     0,     0,     0,
       0,    34,     0,     0,    35,    36,    37,   442,     0,   443,
       0,     0,    19,    20,    21,    22,    23,     0,    24,    25,
       0,     0,     0,     0,     0,    26,     0,     0,     0,    27,
       0,     0,     0,     0,     0,     0,    30,     0,     0,     0,
      31,   333,    32,    12,     0,     0,     0,     0,     0,     0,
      34,     0,     0,    35,    36,    37,    38,     0,    39,     0,
       0,    19,    20,    21,    22,    23,     0,    24,    25,     0,
       0,     0,     0,     0,    26,     0,     0,     0,    27,     0,
       0,     0,     0,     0,     0,    30,     0,     0,     0,    31,
     334,    32,    12,     0,     0,     0,     0,     0,     0,    34,
       0,     0,    35,    36,    37,    38,     0,    39,     0,     0,
      19,    20,    21,    22,    23,     0,    24,    25,     0,     0,
       0,     0,     0,    26,     0,     0,     0,    27,     0,     0,
       0,     0,     0,     0,    30,     0,     0,     0,    31,   335,
      32,    12,     0,     0,     0,     0,     0,     0,    34,     0,
       0,    35,    36,    37,    38,     0,    39,     0,     0,    19,
      20,    21,    22,    23,     0,    24,    25,     0,     0,     0,
       0,     0,    26,     0,     0,     0,    27,     0,     0,     0,
       0,     0,     0,    30,     0,     0,     0,    31,   336,    32,
      12,     0,     0,     0,     0,     0,     0,    34,     0,     0,
      35,    36,    37,    38,     0,    39,     0,     0,    19,    20,
      21,    22,    23,     0,    24,    25,     0,     0,     0,     0,
       0,    26,     0,     0,     0,    27,     0,     0,     0,     0,
       0,     0,    30,     0,     0,     0,    31,   337,    32,    12,
       0,     0,     0,     0,     0,     0,    34,     0,   438,    35,
      36,    37,    38,     0,    39,     0,     0,    19,    20,    21,
      22,    23,     0,    24,    25,     0,     0,     0,     0,     0,
      26,     0,     0,     0,    27,     0,     0,     0,     0,     0,
       0,   439,     0,     0,     0,   440,     0,    32,    12,     0,
       0,     0,     0,     0,     0,    34,     0,   438,    35,    36,
      37,   442,     0,   443,     0,     0,    19,    20,    21,    22,
      23,     0,   496,   497,     0,     0,     0,     0,     0,    26,
       0,     0,     0,    27,     0,     0,     0,     0,     0,     0,
     439,     0,     0,     0,   440,    12,    32,     0,     0,     0,
       0,     0,     0,     0,    34,     0,     0,    35,    36,    37,
     442,     0,   443,    19,    20,    21,    22,    23,     0,    24,
      25,     0,     0,     0,     0,     0,    26,     0,     0,     0,
      27,     0,     0,     0,     0,     0,     0,    30,     0,     0,
       0,    31,    12,    32,     0,     0,     0,     0,     0,     0,
       0,    34,     0,     0,    35,    36,    37,    38,     0,    39,
      19,    20,    21,    22,    23,     0,    93,    94,     0,     0,
    -316,     0,     0,    26,     0,     0,     0,    27,     0,  -316,
    -316,  -316,  -316,  -316,    30,  -316,  -316,     0,    31,     0,
      32,     0,     0,  -316,  -316,     0,  -316,     0,    34,     0,
       0,    35,    36,    37,    38,     0,    39,  -316,     0,  -316,
       0,  -316,     0,     0,     0,     0,     0,  -317,  -316,  -316,
    -316,  -316,  -316,  -316,     0,  -316,  -317,  -317,  -317,  -317,
    -317,     0,  -317,  -317,     0,     0,   438,     0,     0,     0,
    -317,  -317,     0,  -317,     0,    19,    20,    21,    22,    23,
       0,    24,    25,     0,  -317,     0,  -317,     0,  -317,     0,
       0,     0,    27,     0,     0,  -317,  -317,  -317,  -317,  -317,
    -317,     0,  -317,   440,     0,    32,     0,   576,     0,     0,
       0,     0,     0,   438,     0,     0,    35,    36,    37,   442,
       0,   443,    19,    20,    21,    22,    23,     0,    24,    25,
       0,     0,   438,     0,     0,     0,     0,     0,     0,    27,
       0,    19,    20,    21,    22,    23,     0,    24,    25,     0,
     440,     0,    32,     0,   615,     0,     0,     0,    27,     0,
       0,     0,     0,    35,    36,    37,   442,     0,   443,   440,
     635,    32,     0,     0,     0,     0,     0,     0,     0,   438,
       0,     0,    35,    36,    37,   442,     0,   443,    19,    20,
      21,    22,    23,     0,    24,    25,     0,     0,   438,     0,
       0,     0,     0,     0,     0,    27,     0,    19,    20,    21,
      22,    23,     0,    24,    25,     0,   440,   636,    32,     0,
       0,     0,     0,     0,    27,     0,     0,     0,     0,    35,
      36,    37,   442,     0,   443,   440,   637,    32,     0,     0,
       0,     0,     0,     0,     0,   438,     0,     0,    35,    36,
      37,   442,     0,   443,    19,    20,    21,    22,    23,     0,
      24,    25,   176,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,   177,     0,   214,   215,   216,     0,     0,
       0,     0,   440,     0,    32,     0,     0,     0,     0,   217,
     182,     0,     0,     0,     0,    35,    36,    37,   442,     0,
     443,     0,   183,   566,     0,   218,     0,     0,     0,     0,
       0,     0,   219,   220,  -316,  -316,  -316,  -316,  -316,     0,
    -316,  -316,     0,     0,     0,     0,     0,     0,  -316,  -316,
       0,  -316,     0,  -317,  -317,  -317,  -317,  -317,     0,  -317,
    -317,     0,  -316,     0,  -316,     0,  -316,  -317,  -317,     0,
    -317,     0,     0,  -316,  -316,  -316,  -316,  -316,  -316,     0,
    -316,  -317,     0,  -317,     0,  -317,     0,     0,     0,     0,
       0,     0,  -317,  -317,  -317,  -317,  -317,  -317,     0,  -317,
      19,    20,    21,    22,    23,     0,    24,    25,    19,    20,
      21,    22,    23,     0,    24,    25,     0,    27,     0,     0,
       0,     0,     0,     0,     0,    27,     0,     0,    31,     0,
      32,     0,   262,     0,     0,     0,    31,     0,    32,     0,
     324,    35,    36,    37,    38,     0,    39,     0,     0,    35,
      36,    37,    38,     0,    39,    19,    20,    21,    22,    23,
       0,    24,    25,    19,    20,    21,    22,    23,     0,    24,
      25,     0,    27,     0,     0,     0,     0,     0,     0,     0,
      27,     0,     0,    31,   338,    32,     0,     0,     0,     0,
       0,    31,   339,    32,     0,     0,    35,    36,    37,    38,
       0,    39,     0,     0,    35,    36,    37,    38,     0,    39,
      19,    20,    21,    22,    23,     0,    24,    25,    19,    20,
      21,    22,    23,     0,    24,    25,     0,    27,     0,     0,
       0,     0,     0,     0,     0,    27,     0,     0,    31,   346,
      32,     0,     0,     0,     0,     0,    31,     0,    32,     0,
       0,    35,    36,    37,    38,     0,    39,     0,     0,    35,
      36,    37,    38,     0,    39
};

static const short int yycheck[] =
{
       4,    31,   163,   378,    59,     9,    31,    45,    59,    16,
     246,    51,    75,    31,     4,   172,    72,     9,    54,    17,
     211,   284,   443,   228,   229,   147,    30,    31,   264,    33,
     561,   528,     8,    46,    38,    39,    10,   430,    74,    33,
       0,    20,    16,     4,    33,   438,   515,    10,   579,    30,
      24,   148,   427,    16,   551,   212,    60,    61,    62,     3,
      54,    24,   440,     7,    52,    72,   535,    71,    62,    13,
       4,    60,    33,    62,   517,    27,   139,    41,    52,   201,
      61,    71,    61,   614,    21,    61,   141,   323,    40,    52,
     141,    37,    33,   536,    98,   135,    38,    31,   439,   290,
      44,    62,   138,    67,   573,   202,    98,    31,    37,   165,
     140,   452,    57,   117,   139,   155,   491,   121,    60,    20,
      31,    62,    52,    53,    68,    69,     4,   145,    33,    34,
     252,   574,   121,    57,   512,     4,   117,    71,   142,   143,
     144,   145,   146,   147,   148,   225,   226,   227,   152,    79,
     142,   143,   530,   166,   532,   686,   253,     4,   165,   500,
      21,   424,   425,   152,   369,   146,   184,    61,   172,   666,
     188,   175,    38,   514,    31,   231,    38,   368,    61,    25,
     184,    52,    53,   187,   188,    61,    46,    47,   566,    61,
     568,   195,   533,    33,    34,    35,    36,   201,   202,    58,
      57,   576,    52,    53,    64,    61,    52,    53,   212,   213,
     144,    71,    72,    59,   195,    52,    53,   221,   639,    61,
      60,   213,   437,   380,   231,    61,   647,    77,    61,   570,
     248,    77,   250,   289,    61,   471,   234,   241,   172,   243,
     244,   175,   246,   247,   248,   249,   250,   251,   252,   253,
      52,    53,   241,   187,     4,   247,   260,    61,   262,     9,
     264,   265,   266,   267,   268,   426,   270,   271,   272,   273,
     251,   260,   262,   280,    25,    52,    53,    61,   212,    61,
      30,    31,   289,    33,   499,    61,    38,   221,    38,    39,
     505,    61,   441,   508,   374,   375,   376,   377,   302,    52,
      53,    52,    53,    55,    56,    61,   455,   456,    59,     8,
      60,    61,    62,   302,    61,   249,    33,    34,    25,   323,
     324,    71,   697,    15,    61,    61,    77,    61,   262,    52,
      53,    61,   243,   244,    26,    61,    59,   552,    61,    61,
      61,   421,   422,   423,    20,    52,    53,    25,    98,   564,
      61,    43,    59,   502,   265,   266,   267,   268,    61,   270,
     271,   272,   273,    55,    56,    61,    61,   117,    61,    61,
     519,   121,    79,    61,    52,    53,   380,   440,    61,    61,
     541,    59,   386,   387,   388,   440,    61,    61,    58,   440,
      57,    37,   142,   143,   144,   145,   146,   147,   148,   454,
     440,    79,   152,   454,   440,   445,    37,   556,    52,    61,
     440,    20,   448,   324,     5,   440,    61,    58,     9,    61,
     450,    61,   172,    61,   449,   175,   575,    61,    19,    61,
      21,   494,    23,     8,   184,    52,    58,   187,   188,    52,
       5,    61,    77,    79,     9,   195,   380,   440,   511,   442,
     443,   201,   202,    77,    19,   604,    79,   493,    23,    61,
      61,   516,   212,   213,   504,   516,    58,   471,     3,   494,
       3,   221,     7,   509,     7,   386,   387,   388,    13,    52,
      13,    52,   522,   513,     8,     8,   511,    33,    34,    35,
      36,   241,    33,   243,   244,    20,   246,   247,   248,   249,
     250,   251,   252,   253,   542,    33,    34,    35,    36,    44,
     260,    44,   262,    52,   264,   265,   266,   267,   268,    59,
     270,   271,   272,   273,    61,   373,    61,     4,    61,     4,
     378,    52,     9,    68,    69,    68,    69,     5,    52,   569,
     565,     9,    33,    34,    35,    36,    20,    57,    57,    17,
      18,    19,   302,    30,    31,    23,    33,    20,    61,    61,
      61,    38,    39,    52,    53,   558,   559,    61,    61,   599,
      59,   601,    61,   323,   324,   600,     8,    53,    61,   427,
      77,    77,    61,    60,    61,    62,    15,   580,   613,   582,
     583,    15,   440,   586,    71,   588,   589,    26,   591,    79,
      52,    53,    26,     8,    28,    29,    30,    59,    79,    61,
      53,    58,    61,   160,    43,   434,   539,    15,    42,    43,
     162,    98,   615,   291,   469,   469,    55,    56,    26,   541,
     380,    55,    56,   426,    58,   234,   386,   387,   388,   547,
     117,    65,    66,   491,   121,    43,   639,   208,   483,   696,
     654,   550,    52,    53,   647,   175,   519,    55,    56,    59,
     152,    61,   510,    61,   529,   142,   143,   144,   145,   146,
     147,   148,   241,    31,   449,   152,   669,   670,   671,    31,
     528,   529,    31,   531,    39,   440,    15,   360,   556,   608,
      -1,   440,   696,   165,   440,   172,   360,    26,   175,   360,
     693,    -1,    15,   551,    -1,   553,    -1,   184,    -1,    -1,
     187,   188,    -1,    26,    43,    28,    29,    30,   195,   567,
     654,   471,    -1,    -1,   201,   202,    55,    56,   576,    42,
      43,    -1,    -1,    -1,    -1,   212,   213,    -1,    -1,    -1,
      -1,    -1,    55,    56,   221,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   696,    -1,   241,    -1,   243,   244,    -1,   246,
     247,   248,   249,   250,   251,   252,   253,    -1,    -1,    -1,
      -1,     4,    -1,   260,    -1,   262,     9,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    -1,
      -1,    -1,    -1,    -1,    -1,    38,    39,    -1,   666,    -1,
      -1,    -1,     0,     1,    -1,   302,    -1,     5,     6,    -1,
      -1,     9,    10,    11,    12,    -1,    14,    -1,    61,    17,
      18,    19,    -1,    21,    22,    23,   323,   324,    71,   697,
      -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    51,    -1,    98,    54,    -1,    56,    -1,
      -1,    -1,    60,    -1,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,   117,    73,    74,    75,    76,    -1,
      78,    -1,    -1,   380,   654,    -1,    -1,    -1,    -1,   386,
     387,   388,    -1,    -1,     3,    -1,    -1,    -1,     7,   142,
     143,   144,   145,   146,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,    27,    28,
      29,    30,    -1,    -1,    -1,    34,   696,    36,    -1,   172,
      -1,    -1,   175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   184,    -1,    -1,   187,   188,    55,    56,    -1,    58,
      -1,    -1,   195,    62,    -1,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    -1,    -1,   212,
     213,    -1,    -1,    -1,   471,    -1,    -1,    -1,   221,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     243,   244,    -1,   246,   247,   248,   249,   250,   251,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   262,
      -1,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,     3,    -1,    -1,    -1,     7,    -1,    -1,    10,    -1,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    23,    -1,    -1,    26,    27,    28,    29,    30,    -1,
      32,    33,    34,    35,    36,    -1,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    -1,    49,    -1,    -1,
     323,   324,    -1,    55,    56,    -1,    58,    -1,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    -1,    78,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,     7,    -1,    -1,
      10,    -1,    -1,    13,    14,    15,    -1,   380,    -1,    -1,
      -1,    -1,    -1,   386,   387,   388,    26,    27,    28,    29,
      30,    -1,    32,    33,    34,    35,    36,   654,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    55,    56,    -1,    58,    -1,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,     3,    78,   696,
      -1,     7,    -1,    -1,    15,    -1,    -1,    13,    14,    15,
      -1,    -1,    -1,    -1,    -1,    26,    -1,    28,    29,    30,
      26,    27,    28,    29,    30,    -1,    -1,    -1,   471,    -1,
      -1,    42,    43,    -1,    40,    41,    42,    43,    44,    45,
      46,    47,    -1,    49,    55,    56,    -1,    58,    -1,    55,
      56,    -1,    58,    -1,    65,    66,    62,    -1,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      10,    -1,    -1,    -1,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    15,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    26,    56,    28,    29,    30,
      60,    -1,    62,    63,    10,    -1,    -1,    -1,    14,    -1,
      70,    42,    43,    73,    74,    75,    76,    23,    78,    79,
      -1,    -1,    -1,    -1,    55,    56,    32,    33,    34,    35,
      36,    -1,    38,    39,    65,    66,    -1,    -1,    15,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    26,
      56,    28,    29,    30,    60,    -1,    62,    63,    10,    -1,
      -1,    -1,    14,    -1,    70,    42,    43,    73,    74,    75,
      76,    23,    78,    79,    -1,    -1,    -1,    -1,    55,    56,
      32,    33,    34,    35,    36,    -1,    38,    39,    65,    66,
      -1,   654,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    -1,
      62,    63,    10,    -1,    -1,    -1,    14,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    23,    78,    79,    -1,    -1,
      -1,    -1,    -1,   696,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    60,    10,    62,    63,    -1,    14,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    79,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    60,    10,    62,    63,    -1,    14,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    79,    -1,    -1,    -1,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    60,    10,    62,    63,    -1,    14,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    79,    -1,    -1,    -1,    32,    33,    34,
      35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    60,    10,    62,    63,    -1,
      14,    -1,    -1,    -1,    -1,    70,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    79,    -1,    -1,    -1,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    60,    -1,    62,    63,
      10,    -1,    -1,    -1,    14,    -1,    70,    -1,    -1,    73,
      74,    75,    76,    23,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      60,    -1,    62,    63,    -1,    -1,    -1,    10,    -1,    -1,
      70,    14,    -1,    73,    74,    75,    76,    77,    78,    -1,
      23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      33,    34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    61,    62,
      63,    10,    -1,    -1,    -1,    14,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    23,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    60,    -1,    62,    63,    -1,    -1,    -1,    10,    -1,
      -1,    70,    14,    -1,    73,    74,    75,    76,    77,    78,
      -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      32,    33,    34,    35,    36,    -1,    38,    39,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    -1,
      62,    63,    -1,    -1,    -1,    10,    -1,    -1,    70,    14,
      -1,    73,    74,    75,    76,    77,    78,    -1,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    34,
      35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    60,    -1,    62,    63,    -1,
      -1,    -1,    10,    -1,    -1,    70,    14,    -1,    73,    74,
      75,    76,    77,    78,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    60,    61,    62,    63,    10,    -1,    -1,    -1,
      14,    -1,    70,    -1,    -1,    73,    74,    75,    76,    23,
      78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    60,    61,    62,    63,
      10,    -1,    -1,    -1,    14,    -1,    70,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    10,    -1,    -1,
      60,    14,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    73,    74,    75,    76,    77,    78,    32,
      33,    34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    61,    62,
      63,    10,    -1,    -1,    -1,    14,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    10,    -1,
      -1,    60,    14,    62,    63,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    73,    74,    75,    76,    77,    78,
      32,    33,    34,    35,    36,    -1,    38,    39,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    10,    -1,    -1,    60,    14,
      62,    63,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    77,    78,    32,    33,    34,
      35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    60,    -1,    62,    63,    -1,
      -1,    -1,    10,    -1,    -1,    70,    14,    -1,    73,    74,
      75,    76,    77,    78,    -1,    23,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    10,
      -1,    -1,    60,    14,    62,    63,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    32,    33,    34,    35,    36,    -1,    38,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    60,
      61,    62,    63,    10,    -1,    -1,    -1,    14,    -1,    70,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    60,    61,    62,    63,    10,    -1,    -1,
      -1,    14,    -1,    70,    -1,    -1,    73,    74,    75,    76,
      23,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,
      33,    34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    -1,    62,
      63,    10,    -1,    -1,    -1,    14,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    23,    78,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      10,    60,    61,    62,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      -1,    -1,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    10,    -1,    -1,
      60,    14,    62,    63,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    73,    74,    75,    76,    -1,    78,    32,
      33,    34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    10,    -1,    -1,    60,    14,    62,
      63,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    10,    60,    61,    62,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    23,    73,    74,    75,
      76,    -1,    78,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    10,    60,    -1,    62,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    23,    73,    74,    75,    76,
      -1,    78,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    10,
      -1,    -1,    60,    14,    62,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    32,    33,    34,    35,    36,    -1,    38,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    10,    -1,    -1,    60,
      14,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    60,    -1,    62,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    23,    73,
      74,    75,    76,    -1,    78,    -1,    -1,    32,    33,    34,
      35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    60,    61,    62,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    23,    73,    74,
      75,    76,    -1,    78,    -1,    -1,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    60,    61,    62,    14,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    23,    73,    74,    75,
      76,    -1,    78,    -1,    -1,    32,    33,    34,    35,    36,
      -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,
      -1,    -1,    -1,    60,    61,    62,    14,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    -1,    23,    73,    74,    75,    76,
      -1,    78,    -1,    -1,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,
      -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,
      -1,    -1,    60,    61,    62,    14,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    -1,    23,    73,    74,    75,    76,    -1,
      78,    -1,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    60,    61,    62,    14,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      -1,    -1,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,
      60,    61,    62,    14,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,    -1,    73,    74,    75,    76,    -1,    78,    -1,
      -1,    32,    33,    34,    35,    36,    -1,    38,    39,    -1,
      -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    60,
      61,    62,    14,    -1,    -1,    -1,    -1,    -1,    -1,    70,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    -1,    -1,
      32,    33,    34,    35,    36,    -1,    38,    39,    -1,    -1,
      -1,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    61,
      62,    14,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    -1,    -1,    32,
      33,    34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,
      -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,
      -1,    -1,    -1,    56,    -1,    -1,    -1,    60,    61,    62,
      14,    -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    -1,
      73,    74,    75,    76,    -1,    78,    -1,    -1,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,
      -1,    -1,    56,    -1,    -1,    -1,    60,    61,    62,    14,
      -1,    -1,    -1,    -1,    -1,    -1,    70,    -1,    23,    73,
      74,    75,    76,    -1,    78,    -1,    -1,    32,    33,    34,
      35,    36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,
      -1,    56,    -1,    -1,    -1,    60,    -1,    62,    14,    -1,
      -1,    -1,    -1,    -1,    -1,    70,    -1,    23,    73,    74,
      75,    76,    -1,    78,    -1,    -1,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    -1,    -1,    45,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      56,    -1,    -1,    -1,    60,    14,    62,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    -1,    -1,    73,    74,    75,
      76,    -1,    78,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    -1,    -1,    -1,    -1,    -1,    56,    -1,    -1,
      -1,    60,    14,    62,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      32,    33,    34,    35,    36,    -1,    38,    39,    -1,    -1,
      23,    -1,    -1,    45,    -1,    -1,    -1,    49,    -1,    32,
      33,    34,    35,    36,    56,    38,    39,    -1,    60,    -1,
      62,    -1,    -1,    46,    47,    -1,    49,    -1,    70,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    60,    -1,    62,
      -1,    64,    -1,    -1,    -1,    -1,    -1,    23,    71,    72,
      73,    74,    75,    76,    -1,    78,    32,    33,    34,    35,
      36,    -1,    38,    39,    -1,    -1,    23,    -1,    -1,    -1,
      46,    47,    -1,    49,    -1,    32,    33,    34,    35,    36,
      -1,    38,    39,    -1,    60,    -1,    62,    -1,    64,    -1,
      -1,    -1,    49,    -1,    -1,    71,    72,    73,    74,    75,
      76,    -1,    78,    60,    -1,    62,    -1,    64,    -1,    -1,
      -1,    -1,    -1,    23,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    32,    33,    34,    35,    36,    -1,    38,    39,
      -1,    -1,    23,    -1,    -1,    -1,    -1,    -1,    -1,    49,
      -1,    32,    33,    34,    35,    36,    -1,    38,    39,    -1,
      60,    -1,    62,    -1,    64,    -1,    -1,    -1,    49,    -1,
      -1,    -1,    -1,    73,    74,    75,    76,    -1,    78,    60,
      61,    62,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    23,
      -1,    -1,    73,    74,    75,    76,    -1,    78,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    -1,    23,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    32,    33,    34,
      35,    36,    -1,    38,    39,    -1,    60,    61,    62,    -1,
      -1,    -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    60,    61,    62,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    23,    -1,    -1,    73,    74,
      75,    76,    -1,    78,    32,    33,    34,    35,    36,    -1,
      38,    39,    15,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    49,    -1,    26,    -1,    28,    29,    30,    -1,    -1,
      -1,    -1,    60,    -1,    62,    -1,    -1,    -1,    -1,    42,
      43,    -1,    -1,    -1,    -1,    73,    74,    75,    76,    -1,
      78,    -1,    55,    56,    -1,    58,    -1,    -1,    -1,    -1,
      -1,    -1,    65,    66,    32,    33,    34,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    -1,    -1,    -1,    46,    47,
      -1,    49,    -1,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    60,    -1,    62,    -1,    64,    46,    47,    -1,
      49,    -1,    -1,    71,    72,    73,    74,    75,    76,    -1,
      78,    60,    -1,    62,    -1,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    72,    73,    74,    75,    76,    -1,    78,
      32,    33,    34,    35,    36,    -1,    38,    39,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    60,    -1,
      62,    -1,    64,    -1,    -1,    -1,    60,    -1,    62,    -1,
      64,    73,    74,    75,    76,    -1,    78,    -1,    -1,    73,
      74,    75,    76,    -1,    78,    32,    33,    34,    35,    36,
      -1,    38,    39,    32,    33,    34,    35,    36,    -1,    38,
      39,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      49,    -1,    -1,    60,    61,    62,    -1,    -1,    -1,    -1,
      -1,    60,    61,    62,    -1,    -1,    73,    74,    75,    76,
      -1,    78,    -1,    -1,    73,    74,    75,    76,    -1,    78,
      32,    33,    34,    35,    36,    -1,    38,    39,    32,    33,
      34,    35,    36,    -1,    38,    39,    -1,    49,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    49,    -1,    -1,    60,    61,
      62,    -1,    -1,    -1,    -1,    -1,    60,    -1,    62,    -1,
      -1,    73,    74,    75,    76,    -1,    78,    -1,    -1,    73,
      74,    75,    76,    -1,    78
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    81,    82,     0,    83,     1,     5,     6,     9,    10,
      11,    12,    14,    17,    18,    19,    21,    22,    23,    32,
      33,    34,    35,    36,    38,    39,    45,    49,    51,    54,
      56,    60,    62,    63,    70,    73,    74,    75,    76,    78,
      84,    86,    88,    89,   101,   103,   104,   105,   113,   120,
     131,   133,   134,   135,   136,   150,   151,   152,   153,   154,
     155,   170,   176,   177,   181,   191,   194,   197,    52,   114,
     115,   116,    21,   148,   149,   150,    37,    85,    37,    87,
     198,   203,   204,    33,    35,   118,   119,   188,   191,   195,
      38,    55,    56,    38,    39,   152,     3,     7,    10,    13,
      14,    15,    26,    27,    28,    29,    30,    40,    41,    42,
      43,    44,    45,    46,    47,    49,    55,    56,    58,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,   144,   146,   147,   148,   149,   150,
     151,   154,   159,   162,   164,   166,   168,   172,   174,   186,
     187,   132,   177,    77,   144,   146,   183,    79,   183,    52,
      53,    52,    53,    90,     9,    21,   104,     9,   105,   121,
      27,    40,   159,    41,    67,   162,    15,    26,    28,    29,
      30,    42,    43,    55,    56,    65,    66,   143,   166,     3,
       7,    13,    44,    68,    69,   168,    46,    47,    64,    71,
      72,   172,   174,   177,   152,   177,    57,    52,    53,   131,
     198,   203,    20,   162,    28,    29,    30,    42,    58,    65,
      66,   164,     4,     4,    33,    34,    35,    36,    31,    57,
      96,     4,    95,    52,    53,    38,    38,    20,   148,     8,
     145,   177,    52,    53,    59,    61,   159,   162,    56,   164,
     166,   168,   172,   174,   148,   148,   150,   151,   152,   153,
     155,    61,    64,   132,   159,    25,    52,    53,    59,    77,
      25,    52,    53,    59,    79,    85,    87,    33,    34,    36,
      60,   106,   108,   189,   190,   192,   193,   196,   197,    21,
     203,   204,    58,   134,   135,     8,   151,   150,   151,    20,
     152,   153,   155,   198,   202,   115,    58,    96,   134,   148,
     150,    37,    37,   199,   199,   199,   199,   202,   202,    91,
     203,    52,   119,    20,    64,   145,    61,    61,   144,   182,
     144,    61,   147,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,   131,    77,   144,
      77,   144,    77,   144,   144,    79,   144,    79,    79,   144,
     198,   200,   201,    52,    53,    58,   110,   110,   203,    31,
      96,    95,   122,   123,    33,    34,    35,    36,   117,    93,
       8,    52,    58,    97,   147,   144,    52,    53,    59,    61,
      61,    77,    77,    79,    79,     3,     7,    13,    14,    15,
      26,    27,    28,    29,    30,    55,    56,    58,    62,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,   186,   192,   193,    61,    61,   107,   109,    33,    62,
       4,   112,    96,   202,    92,    52,    58,    10,    23,    56,
      60,    63,    76,    78,   137,   139,   140,   141,   142,   165,
     167,   169,   170,   171,   173,   175,   176,   178,   181,   194,
     199,   199,   199,   199,   137,    52,   134,    98,    99,   100,
      52,     8,    61,   144,    61,   144,   144,    20,     8,   199,
     199,   199,   110,   110,   108,   137,    33,   189,    94,    52,
      97,   124,   161,   163,   165,   189,    38,    39,   169,    10,
      56,    61,    63,   156,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   172,   173,   174,   138,   178,
      77,   156,   158,   185,    79,   156,   185,   125,   159,   162,
      56,   143,   166,   168,   169,   172,   174,   178,   178,    59,
     101,   102,   103,   147,    61,    54,   111,   111,    52,    52,
     137,    20,   162,   164,   161,   157,   178,    52,    53,    59,
      61,   159,   161,   161,   162,   165,    56,   164,   166,   167,
     168,   169,   171,   172,   174,   175,    64,   138,    57,   159,
      25,    52,    53,    59,    77,    57,    25,    52,    53,    59,
      79,    10,    16,    24,    52,   126,   127,   140,   141,   167,
     165,   167,   169,   171,   175,    99,   106,    38,    60,   112,
     125,   140,   161,   165,    20,    64,   157,    61,    61,   156,
     184,   156,    61,   160,    61,    61,    61,    61,    61,    61,
      61,    61,    61,    61,    61,    61,    61,    61,   137,   179,
      77,   156,    77,   156,    77,   156,   156,   180,    79,   156,
      79,    79,   156,   156,   128,    40,    41,    42,    43,    44,
      45,    46,    47,    49,   187,    52,     8,   160,   156,    52,
      53,    59,    61,    61,   156,   185,    77,    77,   185,    79,
      79,   129,   130,   131,    61,   140,     8,    61,   156,    61,
     156,   156,    52,    53,    77,    79,    53,    58,   160,    61,
     130,   137
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 112 "qc.y"
    { srcstate(); }
    break;

  case 5:
#line 118 "qc.y"
    { import(); newdecl(); }
    break;

  case 6:
#line 120 "qc.y"
    { include(); newdecl(); }
    break;

  case 7:
#line 122 "qc.y"
    { newdecl(); }
    break;

  case 8:
#line 124 "qc.y"
    { newdecl(); }
    break;

  case 9:
#line 126 "qc.y"
    { newrule(); }
    break;

  case 10:
#line 128 "qc.y"
    { newrule(); }
    break;

  case 12:
#line 137 "qc.y"
    { yyerrok; srcstate(); newrule(); newdecl(); }
    break;

  case 15:
#line 145 "qc.y"
    { add_import((yyvsp[0].sval), NULL); }
    break;

  case 16:
#line 147 "qc.y"
    { add_import((yyvsp[-2].sval), (yyvsp[0].sval)); }
    break;

  case 19:
#line 155 "qc.y"
    { add_import((yyvsp[0].sval), NULL); }
    break;

  case 20:
#line 157 "qc.y"
    { add_import((yyvsp[-2].sval), (yyvsp[0].sval)); }
    break;

  case 21:
#line 161 "qc.y"
    { priority((yyvsp[0].zval)); mpz_clear((yyvsp[0].zval)); }
    break;

  case 22:
#line 163 "qc.y"
    { priority((yyvsp[0].zval)); mpz_clear((yyvsp[0].zval)); }
    break;

  case 23:
#line 165 "qc.y"
    { mpz_neg((yyvsp[0].zval),(yyvsp[0].zval));
				  priority((yyvsp[0].zval)); mpz_clear((yyvsp[0].zval)); }
    break;

  case 24:
#line 170 "qc.y"
    { type = 0; }
    break;

  case 26:
#line 173 "qc.y"
    { if (!(symtb[(yyvsp[-2].ival)].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else
				    astype((yyvsp[-2].ival), (yyvsp[-1].ival), flags); }
    break;

  case 27:
#line 179 "qc.y"
    { if (!(symtb[(yyvsp[-2].ival)].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else
				    astype((yyvsp[-2].ival), (yyvsp[-1].ival), flags); }
    break;

  case 28:
#line 185 "qc.y"
    { if (checktype((yyvsp[-1].ival)) != NONE &&
				      (symtb[(yyvsp[-1].ival)].flags&DCL))
				    astype((yyvsp[-1].ival), (yyvsp[-3].ival), flags); }
    break;

  case 29:
#line 189 "qc.y"
    { if (checktype((yyvsp[-1].ival)) != NONE &&
				      (symtb[(yyvsp[-1].ival)].flags&DCL))
				    astype((yyvsp[-1].ival), (yyvsp[-3].ival), flags); }
    break;

  case 30:
#line 193 "qc.y"
    { type = dcltype((yyvsp[-1].ival), (yyvsp[0].ival), flags);
				  sflags = flags; fno_min = symtbsz; }
    break;

  case 31:
#line 196 "qc.y"
    { /* check for enumeration type */
				  int enumtype = 1, i;
				  fno_max = symtbsz-1;
				  for (i = fno_min; i <= fno_max; i++)
				    if (!(symtb[i].flags & CST) ||
					symtb[i].argc > 0) {
				      enumtype = 0; break;
				    }
				  if (enumtype) {
				    symtb[type].fno_min = fno_min;
				    symtb[type].fno_max = fno_max;
				  }
				}
    break;

  case 32:
#line 210 "qc.y"
    { type = dcltype((yyvsp[-1].ival), (yyvsp[0].ival), flags);
				  sflags = flags; fno_min = symtbsz; }
    break;

  case 33:
#line 213 "qc.y"
    { int enumtype = 1, i;
				  fno_max = symtbsz-1;
				  for (i = fno_min; i <= fno_max; i++)
				    if (!(symtb[i].flags & CST) ||
					symtb[i].argc > 0) {
				      enumtype = 0; break;
				    }
				  if (enumtype) {
				    symtb[type].fno_min = fno_min;
				    symtb[type].fno_max = fno_max;
				  }
				}
    break;

  case 34:
#line 226 "qc.y"
    { type = dcltype((yyvsp[-1].ival), (yyvsp[0].ival), flags|EXT);
				  sflags = flags; }
    break;

  case 36:
#line 230 "qc.y"
    { type = dcltype((yyvsp[-1].ival), (yyvsp[0].ival), flags|EXT);
				  sflags = flags; }
    break;

  case 38:
#line 236 "qc.y"
    { (yyval.ival) = 0; }
    break;

  case 39:
#line 238 "qc.y"
    { (yyval.ival) = (yyvsp[0].ival); }
    break;

  case 40:
#line 242 "qc.y"
    { (yyval.ival) = 0; }
    break;

  case 41:
#line 244 "qc.y"
    { (yyval.ival) = checktype((yyvsp[0].ival)); }
    break;

  case 46:
#line 255 "qc.y"
    { flags = sflags; }
    break;

  case 53:
#line 269 "qc.y"
    { flags = PRIV; }
    break;

  case 54:
#line 271 "qc.y"
    { flags = 0; }
    break;

  case 57:
#line 279 "qc.y"
    { flags |= CST; }
    break;

  case 58:
#line 281 "qc.y"
    { flags |= SPEC; }
    break;

  case 59:
#line 283 "qc.y"
    { flags |= EXT; }
    break;

  case 60:
#line 285 "qc.y"
    { flags |= VSYM; }
    break;

  case 62:
#line 289 "qc.y"
    { argv = 0; }
    break;

  case 64:
#line 292 "qc.y"
    { if (!(flags & VSYM) || type ||
				      (flags & (EXT|SPEC)) ||
				      (symtb[(yyvsp[-1].ival)].flags & DCL) &&
				      symtb[(yyvsp[-1].ival)].modno == modno &&
				      (symtb[(yyvsp[-1].ival)].flags & VSYM) !=
				      (flags & VSYM)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else {
				    int vno = dclfvar((yyvsp[-1].ival), flags);
				    init_def(); (yyval.xval) = funexpr(vno);
				    debug_info();
				  }
				}
    break;

  case 65:
#line 307 "qc.y"
    { definition((yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 66:
#line 309 "qc.y"
    { if ((flags & VSYM) && ((yyvsp[0].ival) || type) ||
				      (flags & VSYM) && (flags & (EXT|SPEC)) ||
				      (flags & CST) && (flags & EXT) ||
				      !(flags & VSYM) &&
				      isupper(strsp[symtb[(yyvsp[-1].ival)].pname]) ||
				      (symtb[(yyvsp[-1].ival)].flags & DCL) &&
				      symtb[(yyvsp[-1].ival)].modno == modno &&
				      (symtb[(yyvsp[-1].ival)].flags & VSYM) !=
				      (flags & VSYM)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else if (flags & VSYM)
				    dclfvar((yyvsp[-1].ival), flags);
				  else
				    dclfun((yyvsp[-1].ival), type, (yyvsp[0].ival), argv, flags, NONE); }
    break;

  case 67:
#line 325 "qc.y"
    { int prec = (yyvsp[0].ival);
				  if (prec == NONE &&
				      ((yyvsp[-3].ival) < BUILTIN || symtb[(yyvsp[-3].ival)].modno == modno))
				    prec = symtb[(yyvsp[-3].ival)].prec;
				  if (prec == NONE) prec = 2;
				  if ((flags & VSYM) ||
				      (flags & CST) && (flags & EXT) ||
				      (prec == 5 || prec == 9) && (yyvsp[-1].ival) != 1 ||
				      (prec != 5 && prec != 9) && (yyvsp[-1].ival) != 2) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else
				    dclfun((yyvsp[-3].ival), type, (yyvsp[-1].ival), argv, flags, prec); }
    break;

  case 68:
#line 339 "qc.y"
    { if (!(symtb[(yyvsp[-2].ival)].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else if ((flags & VSYM) && ((yyvsp[-1].ival) || type) ||
					     (flags & VSYM) && (flags & (EXT|SPEC)) ||
					     (flags & CST) && (flags & EXT) ||
					     !(flags & VSYM) &&
					     isupper(strsp[symtb[(yyvsp[-2].ival)].pname]) ||
					     (symtb[(yyvsp[-2].ival)].flags & DCL) &&
					     (symtb[(yyvsp[-2].ival)].flags & VSYM) !=
					     (flags & VSYM) ||
					     type ||
					     (yyvsp[0].ival) && symtb[(yyvsp[0].ival)].modno == modno &&
					     (symtb[(yyvsp[0].ival)].flags&DCL)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else if (flags & VSYM)
				    asfvar((yyvsp[-2].ival), (yyvsp[0].ival), flags);
				  else
				    asfun((yyvsp[-2].ival), (yyvsp[0].ival), (yyvsp[-1].ival), argv, flags, NONE); }
    break;

  case 69:
#line 360 "qc.y"
    { int prec = (yyvsp[-1].ival);
				  if (prec == NONE) prec = symtb[(yyvsp[-4].ival)].prec;
				  if (!(symtb[(yyvsp[-4].ival)].flags&DCL)) {
				    yyerror(qcmsg[AS_DCL_ERROR]);
				    YYERROR;
				  } else if ((flags & VSYM) ||
					     (flags & CST) && (flags & EXT) ||
					     type ||
					     (yyvsp[0].ival) && symtb[(yyvsp[0].ival)].modno == modno &&
					     (symtb[(yyvsp[0].ival)].flags&DCL) ||
					     prec == NONE ||
					     (prec == 5 || prec == 9) && (yyvsp[-2].ival) != 1 ||
					     (prec != 5 && prec != 9) && (yyvsp[-2].ival) != 2) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  } else
				    asfun((yyvsp[-4].ival), (yyvsp[0].ival), (yyvsp[-2].ival), argv, flags, prec); }
    break;

  case 70:
#line 380 "qc.y"
    { (yyval.ival) = 0; }
    break;

  case 71:
#line 382 "qc.y"
    { if (flags & SPEC)
				    if ((yyvsp[-1].ival) < sizeof(unsigned long)*8)
				      argv |= 1<<(yyvsp[-1].ival);
				    else {
				      yyerror(qcmsg[DCL_ERROR]);
				      YYERROR;
				    }
				  (yyval.ival) = (yyvsp[-1].ival)+1; }
    break;

  case 72:
#line 391 "qc.y"
    { if (!(flags & SPEC)) {
				    yyerror(qcmsg[DCL_ERROR]);
				    YYERROR;
				  }
				  (yyval.ival) = (yyvsp[-2].ival)+1; }
    break;

  case 73:
#line 399 "qc.y"
    { (yyval.ival) = NONE; }
    break;

  case 74:
#line 401 "qc.y"
    { (yyval.ival) = precval((yyvsp[0].zval)); }
    break;

  case 75:
#line 403 "qc.y"
    { int prec = symtb[(yyvsp[-1].ival)].prec;
			  if (prec >= 0 && prec <= 9 && prec != 8)
			    (yyval.ival) = prec;
			  else {
			    yyerror(qcmsg[INVALID_PREC]);
			    (yyval.ival) = NONE;
			  }
			}
    break;

  case 76:
#line 414 "qc.y"
    { (yyval.ival) = 0; }
    break;

  case 77:
#line 416 "qc.y"
    { (yyval.ival) = (yyvsp[0].ival); }
    break;

  case 82:
#line 427 "qc.y"
    { init_def(); }
    break;

  case 83:
#line 429 "qc.y"
    { debug_info(); }
    break;

  case 84:
#line 431 "qc.y"
    { definition((yyvsp[-3].xval), (yyvsp[0].xval)); }
    break;

  case 87:
#line 439 "qc.y"
    { init_def();
				  if (!(symtb[(yyvsp[0].ival)].flags & VSYM))
				    yyerror(qcmsg[INVALID_DEF]);
				  else {
				    symtb[(yyvsp[0].ival)].flags |= DCL;
				    debug_info();
				    definition(funexpr((yyvsp[0].ival)), NULL);
				  }
				}
    break;

  case 88:
#line 451 "qc.y"
    { debug_info(); left_hand_side((yyvsp[0].xval)); mark(); }
    break;

  case 90:
#line 455 "qc.y"
    { fix_debug_info(); start_qualifiers(); }
    break;

  case 91:
#line 457 "qc.y"
    { qualifiers(); right_hand_side((yyvsp[-2].xval)); }
    break;

  case 92:
#line 459 "qc.y"
    { fix_debug_info(); start_qualifiers(); }
    break;

  case 93:
#line 461 "qc.y"
    { qualifiers(); right_hand_side((yyvsp[-2].xval)); }
    break;

  case 95:
#line 466 "qc.y"
    { add_qualifier((yyvsp[0].xval)); }
    break;

  case 97:
#line 471 "qc.y"
    { (yyval.xval) = (yyvsp[0].xval); }
    break;

  case 98:
#line 473 "qc.y"
    { (yyval.xval) = NULL; }
    break;

  case 99:
#line 477 "qc.y"
    { start_where_clauses(); }
    break;

  case 100:
#line 479 "qc.y"
    { end_where_clauses(); }
    break;

  case 103:
#line 487 "qc.y"
    { add_where_clause((yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 105:
#line 493 "qc.y"
    { (yyval.xval) = (yyvsp[0].xval); }
    break;

  case 106:
#line 497 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 107:
#line 499 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 109:
#line 504 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 111:
#line 509 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::ifelse"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = ternexpr(fno, (yyvsp[-4].xval), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 112:
#line 517 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::when"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = binexpr(fno, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 114:
#line 528 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 116:
#line 533 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 118:
#line 537 "qc.y"
    { (yyval.xval) = (yyvsp[0].xval); }
    break;

  case 119:
#line 541 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 120:
#line 543 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 122:
#line 548 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 124:
#line 553 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::ifelse"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = ternexpr(fno, (yyvsp[-4].xval), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 125:
#line 561 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::when"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = binexpr(fno, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 127:
#line 572 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 129:
#line 577 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 130:
#line 580 "qc.y"
    { (yyval.ival) = LEOP; }
    break;

  case 131:
#line 581 "qc.y"
    { (yyval.ival) = GROP; }
    break;

  case 132:
#line 582 "qc.y"
    { (yyval.ival) = LEQOP; }
    break;

  case 133:
#line 583 "qc.y"
    { (yyval.ival) = GEQOP; }
    break;

  case 134:
#line 584 "qc.y"
    { (yyval.ival) = NEQOP; }
    break;

  case 137:
#line 592 "qc.y"
    { (yyval.xval) = (yyvsp[0].xval); }
    break;

  case 138:
#line 596 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 139:
#line 598 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 141:
#line 603 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 143:
#line 608 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::ifelse"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = ternexpr(fno, (yyvsp[-4].xval), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 144:
#line 616 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::when"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = binexpr(fno, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 146:
#line 627 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 148:
#line 632 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 150:
#line 637 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 151:
#line 639 "qc.y"
    { (yyval.xval) = binexpr(MINOP, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 153:
#line 644 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 155:
#line 650 "qc.y"
    { mpz_neg((yyvsp[0].zval), (yyvsp[0].zval)); (yyval.xval) = intexpr((yyvsp[0].zval)); }
    break;

  case 156:
#line 651 "qc.y"
    { (yyval.xval) = floatexpr(-(yyvsp[0].fval)); }
    break;

  case 157:
#line 652 "qc.y"
    { (yyval.xval) = unexpr(UMINOP, (yyvsp[0].xval)); }
    break;

  case 158:
#line 653 "qc.y"
    { (yyval.xval) = unexpr((yyvsp[-1].ival), (yyvsp[0].xval)); }
    break;

  case 160:
#line 657 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 162:
#line 662 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 164:
#line 667 "qc.y"
    { (yyval.xval) = appexpr((yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 166:
#line 671 "qc.y"
    { (yyval.xval) = (yyvsp[0].xval); }
    break;

  case 167:
#line 675 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 168:
#line 677 "qc.y"
    { (yyval.xval) = binexpr(LAMBDAOP, (yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 170:
#line 682 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 171:
#line 685 "qc.y"
    { (yyval.ival) = SEQOP; }
    break;

  case 174:
#line 691 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::ifelse"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = ternexpr(fno, (yyvsp[-4].xval), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 175:
#line 699 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::when"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.xval) = binexpr(fno, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 177:
#line 710 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 178:
#line 713 "qc.y"
    { (yyval.ival) = RAPPOP; }
    break;

  case 181:
#line 719 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 182:
#line 722 "qc.y"
    { (yyval.ival) = LEOP; }
    break;

  case 183:
#line 723 "qc.y"
    { (yyval.ival) = GROP; }
    break;

  case 184:
#line 724 "qc.y"
    { (yyval.ival) = EQOP; }
    break;

  case 185:
#line 725 "qc.y"
    { (yyval.ival) = LEQOP; }
    break;

  case 186:
#line 726 "qc.y"
    { (yyval.ival) = GEQOP; }
    break;

  case 187:
#line 727 "qc.y"
    { (yyval.ival) = NEQOP; }
    break;

  case 190:
#line 733 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 191:
#line 735 "qc.y"
    { (yyval.xval) = binexpr(MINOP, (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 192:
#line 738 "qc.y"
    { (yyval.ival) = ADDOP; }
    break;

  case 193:
#line 739 "qc.y"
    { (yyval.ival) = CATOP; }
    break;

  case 194:
#line 740 "qc.y"
    { (yyval.ival) = OROP; }
    break;

  case 195:
#line 741 "qc.y"
    { (yyval.ival) = ORELSEOP; }
    break;

  case 198:
#line 747 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 199:
#line 750 "qc.y"
    { (yyval.ival) = MULOP; }
    break;

  case 200:
#line 751 "qc.y"
    { (yyval.ival) = FDIVOP; }
    break;

  case 201:
#line 752 "qc.y"
    { (yyval.ival) = DIVOP; }
    break;

  case 202:
#line 753 "qc.y"
    { (yyval.ival) = MODOP; }
    break;

  case 203:
#line 754 "qc.y"
    { (yyval.ival) = ANDOP; }
    break;

  case 204:
#line 755 "qc.y"
    { (yyval.ival) = ANDTHENOP; }
    break;

  case 207:
#line 762 "qc.y"
    { mpz_neg((yyvsp[0].zval), (yyvsp[0].zval)); (yyval.xval) = intexpr((yyvsp[0].zval)); }
    break;

  case 208:
#line 763 "qc.y"
    { (yyval.xval) = floatexpr(-(yyvsp[0].fval)); }
    break;

  case 209:
#line 764 "qc.y"
    { (yyval.xval) = unexpr(UMINOP, (yyvsp[0].xval)); }
    break;

  case 210:
#line 765 "qc.y"
    { (yyval.xval) = unexpr((yyvsp[-1].ival), (yyvsp[0].xval)); }
    break;

  case 211:
#line 768 "qc.y"
    { (yyval.ival) = HASHOP; }
    break;

  case 212:
#line 769 "qc.y"
    { (yyval.ival) = NOTOP; }
    break;

  case 215:
#line 775 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 216:
#line 778 "qc.y"
    { (yyval.ival) = POWOP; }
    break;

  case 217:
#line 779 "qc.y"
    { (yyval.ival) = IDXOP; }
    break;

  case 220:
#line 785 "qc.y"
    { (yyval.xval) = binexpr((yyvsp[-1].ival), (yyvsp[-2].xval), (yyvsp[0].xval)); }
    break;

  case 221:
#line 788 "qc.y"
    { (yyval.ival) = COMPOP; }
    break;

  case 224:
#line 794 "qc.y"
    { (yyval.xval) = appexpr((yyvsp[-1].xval), (yyvsp[0].xval)); }
    break;

  case 225:
#line 797 "qc.y"
    { (yyval.ival) = QUOTEOP; }
    break;

  case 226:
#line 798 "qc.y"
    { (yyval.ival) = UNQUOTEOP; }
    break;

  case 227:
#line 799 "qc.y"
    { (yyval.ival) = FORCEOP; }
    break;

  case 228:
#line 800 "qc.y"
    { (yyval.ival) = MEMOP; }
    break;

  case 231:
#line 808 "qc.y"
    { checktype((yyvsp[0].ival)); vartb[(yyvsp[-2].ival)].type = (yyvsp[0].ival);
				  (yyval.xval) = varexpr((yyvsp[-2].ival)); }
    break;

  case 232:
#line 814 "qc.y"
    { (yyval.xval) = unexpr((yyvsp[-1].ival), (yyvsp[0].xval)); }
    break;

  case 233:
#line 819 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 234:
#line 822 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 235:
#line 827 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 236:
#line 830 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 237:
#line 835 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 238:
#line 838 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 239:
#line 843 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 240:
#line 846 "qc.y"
    { (yyval.xval) = appexpr(funexpr(MINOP), (yyvsp[-2].xval)); }
    break;

  case 241:
#line 849 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 242:
#line 854 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 243:
#line 857 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 244:
#line 862 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 245:
#line 865 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 246:
#line 870 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 247:
#line 873 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 248:
#line 880 "qc.y"
    { (yyval.xval) = funexpr(VOIDOP); }
    break;

  case 249:
#line 882 "qc.y"
    { (yyval.xval) = (yyvsp[-1].xval); }
    break;

  case 250:
#line 884 "qc.y"
    { (yyval.xval) = pairexpr((yyvsp[-2].xval), funexpr(VOIDOP)); }
    break;

  case 251:
#line 886 "qc.y"
    { (yyval.xval) = pairexpr(pairexpr((yyvsp[-2].xval), funexpr(VOIDOP)),
						funexpr(VOIDOP)); }
    break;

  case 252:
#line 889 "qc.y"
    { (yyval.xval) = pairexpr((yyvsp[-3].xval), (yyvsp[-1].xval)); }
    break;

  case 253:
#line 891 "qc.y"
    { (yyval.xval) = tupleexpr(addexpr((yyvsp[-1].xvval), funexpr(VOIDOP))); }
    break;

  case 254:
#line 893 "qc.y"
    { (yyval.xval) = tupleexpr(addexpr((yyvsp[-2].xvval), funexpr(VOIDOP))); }
    break;

  case 255:
#line 895 "qc.y"
    { if ((yyvsp[-2].xvval)->m < 0) (yyvsp[-2].xvval)->m = 0;
				  (yyval.xval) = tupleexpr(addexpr((yyvsp[-2].xvval), funexpr(VOIDOP))); }
    break;

  case 256:
#line 898 "qc.y"
    { (yyval.xval) = tupleexpr(addexpr((yyvsp[-3].xvval), (yyvsp[-1].xval))); }
    break;

  case 257:
#line 903 "qc.y"
    { (yyval.xval) = funexpr(NILOP); }
    break;

  case 258:
#line 905 "qc.y"
    { (yyval.xval) = listexpr(
				  addexpr((yyvsp[-1].xvval), funexpr(NILOP))); }
    break;

  case 259:
#line 908 "qc.y"
    { (yyval.xval) = listexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(NILOP))); }
    break;

  case 260:
#line 911 "qc.y"
    { if ((yyvsp[-2].xvval)->m < 0) (yyvsp[-2].xvval)->m = 0;
				  (yyval.xval) = listexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(NILOP))); }
    break;

  case 261:
#line 915 "qc.y"
    { (yyval.xval) = listexpr(addexpr((yyvsp[-3].xvval), (yyvsp[-1].xval))); }
    break;

  case 262:
#line 917 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(ENUMOP),
				  listexpr(addexpr((yyvsp[-3].xvval), funexpr(NILOP)))),
				  (yyvsp[-1].xval)); }
    break;

  case 263:
#line 921 "qc.y"
    { (yyval.xval) = appexpr(funexpr(ENUM1OP),
				  listexpr(addexpr((yyvsp[-2].xvval), funexpr(NILOP)))); }
    break;

  case 264:
#line 927 "qc.y"
    { (yyval.xval) = funexpr(SNILOP); }
    break;

  case 265:
#line 929 "qc.y"
    { (yyval.xval) = streamexpr(
				  addexpr((yyvsp[-1].xvval), funexpr(SNILOP))); }
    break;

  case 266:
#line 932 "qc.y"
    { (yyval.xval) = streamexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(SNILOP))); }
    break;

  case 267:
#line 935 "qc.y"
    { if ((yyvsp[-2].xvval)->m < 0) (yyvsp[-2].xvval)->m = 0;
				  (yyval.xval) = streamexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(SNILOP))); }
    break;

  case 268:
#line 939 "qc.y"
    { (yyval.xval) = streamexpr(addexpr((yyvsp[-3].xvval), (yyvsp[-1].xval))); }
    break;

  case 269:
#line 941 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(SENUMOP),
				  listexpr(addexpr((yyvsp[-3].xvval), funexpr(NILOP)))),
				  (yyvsp[-1].xval)); }
    break;

  case 270:
#line 945 "qc.y"
    { (yyval.xval) = appexpr(funexpr(SENUM1OP),
				  listexpr(addexpr((yyvsp[-2].xvval), funexpr(NILOP)))); }
    break;

  case 272:
#line 957 "qc.y"
    { int vno = (yyvsp[0].ival);
				  if (!(symtb[vno].flags&DCL) ||
				      symtb[vno].modno != modno ||
				      !(symtb[vno].flags&VSYM))
				    vno = dclfvar(vno, PRIV|VSYM);
				  (yyval.xval) = funexpr(vno); }
    break;

  case 273:
#line 967 "qc.y"
    { (yyval.xval) = unexpr((yyvsp[-1].ival), (yyvsp[0].xval)); }
    break;

  case 274:
#line 972 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 275:
#line 975 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 276:
#line 980 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 277:
#line 983 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 278:
#line 988 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 279:
#line 991 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 280:
#line 996 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 281:
#line 999 "qc.y"
    { (yyval.xval) = appexpr(funexpr(MINOP), (yyvsp[-2].xval)); }
    break;

  case 282:
#line 1002 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 283:
#line 1007 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 284:
#line 1010 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 285:
#line 1015 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 286:
#line 1018 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 287:
#line 1023 "qc.y"
    { (yyval.xval) = appexpr(funexpr((yyvsp[-1].ival)), (yyvsp[-2].xval)); }
    break;

  case 288:
#line 1026 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(FLIPOP),
						       funexpr((yyvsp[-2].ival))),
					       (yyvsp[-1].xval)); }
    break;

  case 289:
#line 1033 "qc.y"
    { (yyval.xval) = funexpr(VOIDOP); }
    break;

  case 290:
#line 1035 "qc.y"
    { (yyval.xval) = (yyvsp[-1].xval); }
    break;

  case 291:
#line 1037 "qc.y"
    { (yyval.xval) = pairexpr((yyvsp[-2].xval), funexpr(VOIDOP)); }
    break;

  case 292:
#line 1039 "qc.y"
    { (yyval.xval) = pairexpr(pairexpr((yyvsp[-2].xval), funexpr(VOIDOP)),
						funexpr(VOIDOP)); }
    break;

  case 293:
#line 1042 "qc.y"
    { (yyval.xval) = pairexpr((yyvsp[-3].xval), (yyvsp[-1].xval)); }
    break;

  case 294:
#line 1044 "qc.y"
    { (yyval.xval) = tupleexpr(addexpr((yyvsp[-1].xvval), funexpr(VOIDOP))); }
    break;

  case 295:
#line 1046 "qc.y"
    { (yyval.xval) = tupleexpr(addexpr((yyvsp[-2].xvval), funexpr(VOIDOP))); }
    break;

  case 296:
#line 1048 "qc.y"
    { if ((yyvsp[-2].xvval)->m < 0) (yyvsp[-2].xvval)->m = 0;
				  (yyval.xval) = tupleexpr(addexpr((yyvsp[-2].xvval), funexpr(VOIDOP))); }
    break;

  case 297:
#line 1051 "qc.y"
    { (yyval.xval) = tupleexpr(addexpr((yyvsp[-3].xvval), (yyvsp[-1].xval))); }
    break;

  case 298:
#line 1056 "qc.y"
    { (yyval.xval) = funexpr(NILOP); }
    break;

  case 299:
#line 1058 "qc.y"
    { (yyval.xval) = listexpr(
				  addexpr((yyvsp[-1].xvval), funexpr(NILOP))); }
    break;

  case 300:
#line 1061 "qc.y"
    { (yyval.xval) = listexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(NILOP))); }
    break;

  case 301:
#line 1064 "qc.y"
    { if ((yyvsp[-2].xvval)->m < 0) (yyvsp[-2].xvval)->m = 0;
				  (yyval.xval) = listexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(NILOP))); }
    break;

  case 302:
#line 1068 "qc.y"
    { (yyval.xval) = listexpr(addexpr((yyvsp[-3].xvval), (yyvsp[-1].xval))); }
    break;

  case 303:
#line 1070 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(ENUMOP),
				  listexpr(addexpr((yyvsp[-3].xvval), funexpr(NILOP)))),
				  (yyvsp[-1].xval)); }
    break;

  case 304:
#line 1074 "qc.y"
    { (yyval.xval) = appexpr(funexpr(ENUM1OP),
				  listexpr(addexpr((yyvsp[-2].xvval), funexpr(NILOP)))); }
    break;

  case 305:
#line 1077 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::listof"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.ival) = fno; }
    break;

  case 306:
#line 1085 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr((yyvsp[-2].ival)), (yyvsp[-4].xval)),
				  tupleexpr(addexpr((yyvsp[-1].xvval), funexpr(VOIDOP)))); }
    break;

  case 307:
#line 1091 "qc.y"
    { (yyval.xval) = funexpr(SNILOP); }
    break;

  case 308:
#line 1093 "qc.y"
    { (yyval.xval) = streamexpr(
				  addexpr((yyvsp[-1].xvval), funexpr(SNILOP))); }
    break;

  case 309:
#line 1096 "qc.y"
    { (yyval.xval) = streamexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(SNILOP))); }
    break;

  case 310:
#line 1099 "qc.y"
    { if ((yyvsp[-2].xvval)->m < 0) (yyvsp[-2].xvval)->m = 0;
				  (yyval.xval) = streamexpr(
				  addexpr((yyvsp[-2].xvval), funexpr(SNILOP))); }
    break;

  case 311:
#line 1103 "qc.y"
    { (yyval.xval) = streamexpr(addexpr((yyvsp[-3].xvval), (yyvsp[-1].xval))); }
    break;

  case 312:
#line 1105 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr(SENUMOP),
				  listexpr(addexpr((yyvsp[-3].xvval), funexpr(NILOP)))),
				  (yyvsp[-1].xval)); }
    break;

  case 313:
#line 1109 "qc.y"
    { (yyval.xval) = appexpr(funexpr(SENUM1OP),
				  listexpr(addexpr((yyvsp[-2].xvval), funexpr(NILOP)))); }
    break;

  case 314:
#line 1112 "qc.y"
    { static char sym[20];
				  int fno = getfun(strcpy(sym, "cond::streamof"));
				  if (fno == NONE) {
				    yyerror(qcmsg[SYNTAX_ERROR]);
				    YYERROR;
				  } else
				    (yyval.ival) = fno; }
    break;

  case 315:
#line 1120 "qc.y"
    { (yyval.xval) = appexpr(appexpr(funexpr((yyvsp[-2].ival)), (yyvsp[-4].xval)),
				  tupleexpr(addexpr((yyvsp[-1].xvval), funexpr(VOIDOP)))); }
    break;

  case 316:
#line 1130 "qc.y"
    { (yyval.xval) = intexpr((yyvsp[0].zval)); }
    break;

  case 317:
#line 1131 "qc.y"
    { (yyval.xval) = floatexpr((yyvsp[0].fval)); }
    break;

  case 318:
#line 1132 "qc.y"
    { (yyval.xval) = strexpr((yyvsp[0].ival)); }
    break;

  case 319:
#line 1136 "qc.y"
    { (yyval.xval) = funexpr((yyvsp[-1].ival)); }
    break;

  case 320:
#line 1137 "qc.y"
    { (yyval.xval) = funexpr((yyvsp[0].ival)); }
    break;

  case 321:
#line 1138 "qc.y"
    { (yyval.xval) = funexpr((yyvsp[0].ival)); }
    break;

  case 322:
#line 1139 "qc.y"
    { vartb[(yyvsp[0].ival)].type = 0;
				  (yyval.xval) = varexpr((yyvsp[0].ival)); }
    break;

  case 323:
#line 1144 "qc.y"
    { (yyval.xvval) = addexpr(addexpr(exprlist(), (yyvsp[-2].xval)),
					       (yyvsp[0].xval)); }
    break;

  case 324:
#line 1147 "qc.y"
    { (yyval.xvval) = addexpr((yyvsp[-2].xvval), (yyvsp[0].xval)); }
    break;

  case 325:
#line 1149 "qc.y"
    { (yyval.xvval) = groupexpr(addexpr((yyvsp[-2].xvval), (yyvsp[0].xval))); }
    break;

  case 326:
#line 1153 "qc.y"
    { (yyval.xvval) = addexpr(exprlist(), (yyvsp[0].xval)); }
    break;

  case 327:
#line 1155 "qc.y"
    { (yyval.xvval) = addexpr((yyvsp[-2].xvval), (yyvsp[0].xval)); }
    break;

  case 328:
#line 1157 "qc.y"
    { (yyval.xvval) = groupexpr(addexpr((yyvsp[-2].xvval), (yyvsp[0].xval))); }
    break;

  case 329:
#line 1161 "qc.y"
    { (yyval.xvval) = addexpr(addexpr(exprlist(), (yyvsp[-2].xval)),
					       (yyvsp[0].xval)); }
    break;

  case 330:
#line 1164 "qc.y"
    { (yyval.xvval) = addexpr((yyvsp[-2].xvval), (yyvsp[0].xval)); }
    break;

  case 331:
#line 1166 "qc.y"
    { (yyval.xvval) = groupexpr(addexpr((yyvsp[-2].xvval), (yyvsp[0].xval))); }
    break;

  case 332:
#line 1170 "qc.y"
    { (yyval.xvval) = addexpr(exprlist(), (yyvsp[0].xval)); }
    break;

  case 333:
#line 1172 "qc.y"
    { (yyval.xvval) = addexpr((yyvsp[-2].xvval), (yyvsp[0].xval)); }
    break;

  case 334:
#line 1174 "qc.y"
    { (yyval.xvval) = groupexpr(addexpr((yyvsp[-2].xvval), (yyvsp[0].xval))); }
    break;

  case 335:
#line 1177 "qc.y"
    { (yyval.ival) = SEQOP; }
    break;

  case 336:
#line 1178 "qc.y"
    { (yyval.ival) = RAPPOP; }
    break;

  case 337:
#line 1179 "qc.y"
    { (yyval.ival) = LEOP; }
    break;

  case 338:
#line 1180 "qc.y"
    { (yyval.ival) = GROP; }
    break;

  case 339:
#line 1181 "qc.y"
    { (yyval.ival) = EQOP; }
    break;

  case 340:
#line 1182 "qc.y"
    { (yyval.ival) = LEQOP; }
    break;

  case 341:
#line 1183 "qc.y"
    { (yyval.ival) = GEQOP; }
    break;

  case 342:
#line 1184 "qc.y"
    { (yyval.ival) = NEQOP; }
    break;

  case 343:
#line 1185 "qc.y"
    { (yyval.ival) = CATOP; }
    break;

  case 344:
#line 1186 "qc.y"
    { (yyval.ival) = ADDOP; }
    break;

  case 345:
#line 1187 "qc.y"
    { (yyval.ival) = MINOP; }
    break;

  case 346:
#line 1188 "qc.y"
    { (yyval.ival) = OROP; }
    break;

  case 347:
#line 1189 "qc.y"
    { (yyval.ival) = ORELSEOP; }
    break;

  case 348:
#line 1190 "qc.y"
    { (yyval.ival) = MULOP; }
    break;

  case 349:
#line 1191 "qc.y"
    { (yyval.ival) = FDIVOP; }
    break;

  case 350:
#line 1192 "qc.y"
    { (yyval.ival) = DIVOP; }
    break;

  case 351:
#line 1193 "qc.y"
    { (yyval.ival) = MODOP; }
    break;

  case 352:
#line 1194 "qc.y"
    { (yyval.ival) = ANDOP; }
    break;

  case 353:
#line 1195 "qc.y"
    { (yyval.ival) = ANDTHENOP; }
    break;

  case 354:
#line 1196 "qc.y"
    { (yyval.ival) = HASHOP; }
    break;

  case 355:
#line 1197 "qc.y"
    { (yyval.ival) = NOTOP; }
    break;

  case 356:
#line 1198 "qc.y"
    { (yyval.ival) = QUOTEOP; }
    break;

  case 357:
#line 1199 "qc.y"
    { (yyval.ival) = UNQUOTEOP; }
    break;

  case 358:
#line 1200 "qc.y"
    { (yyval.ival) = FORCEOP; }
    break;

  case 359:
#line 1201 "qc.y"
    { (yyval.ival) = MEMOP; }
    break;

  case 360:
#line 1202 "qc.y"
    { (yyval.ival) = POWOP; }
    break;

  case 361:
#line 1203 "qc.y"
    { (yyval.ival) = IDXOP; }
    break;

  case 362:
#line 1204 "qc.y"
    { (yyval.ival) = COMPOP; }
    break;

  case 379:
#line 1232 "qc.y"
    { (yyval.ival) = mkfun((yyvsp[0].sval)); }
    break;

  case 380:
#line 1234 "qc.y"
    { (yyval.ival) = mkfun((yyvsp[0].sval)); }
    break;

  case 381:
#line 1238 "qc.y"
    { (yyval.ival) = mkfun((yyvsp[0].sval)); }
    break;

  case 382:
#line 1242 "qc.y"
    { (yyval.ival) = mkfun((yyvsp[0].sval)); }
    break;

  case 383:
#line 1246 "qc.y"
    { (yyval.ival) = mkvar((yyvsp[0].sval)); }
    break;

  case 384:
#line 1250 "qc.y"
    { (yyval.ival) = mkfvar((yyvsp[0].sval)); }
    break;

  case 385:
#line 1252 "qc.y"
    { (yyval.ival) = mkfvar((yyvsp[0].sval)); }
    break;

  case 386:
#line 1256 "qc.y"
    { (yyval.ival) = mkfvar((yyvsp[0].sval)); }
    break;

  case 387:
#line 1260 "qc.y"
    { (yyval.ival) = mkfvar((yyvsp[0].sval)); }
    break;

  case 388:
#line 1263 "qc.y"
    { context = 1; }
    break;

  case 389:
#line 1266 "qc.y"
    { context = 0; }
    break;

  case 390:
#line 1270 "qc.y"
    { (yyval.ival) = (yyvsp[-1].ival); }
    break;

  case 391:
#line 1274 "qc.y"
    { (yyval.ival) = (yyvsp[-1].ival); }
    break;

  case 392:
#line 1276 "qc.y"
    { (yyval.ival) = (yyvsp[-1].ival); }
    break;

  case 393:
#line 1280 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 394:
#line 1282 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 395:
#line 1284 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 396:
#line 1286 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 397:
#line 1290 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 398:
#line 1292 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 399:
#line 1296 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;

  case 400:
#line 1298 "qc.y"
    { (yyval.ival) = mktype((yyvsp[-1].sval)); }
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 4426 "qc.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 1301 "qc.y"


#ifdef YYBISON
#define SYNTAX_ERROR "parse error"
#else
#define SYNTAX_ERROR "syntax error"
#endif

extern int      yyleng, yylineno;
extern char     *source;

yyerror(s)
	char           *s;
{
	fprintf(stderr, "Error %s, line %d: %s", source, yylineno, s);
	if (strcmp(s, SYNTAX_ERROR) == 0)
		if (*yytext)
			fprintf(stderr, " at or near symbol `%s'",
				utf8_to_sys(yytext));
		else
			fprintf(stderr, " at end of file");
	fprintf(stderr, "\n");
	nerrs++;
}

yywarn(s)
	char           *s;
{
	if (wflag) {
		fprintf(stderr, "Warning %s, line %d: %s\n", source,
			yylineno, s);
		nwarns++;
	}
}

fatal(s)
	char           *s;
{
	if (source && *source)
		fprintf(stderr, "%s: %s: %s -- compilation aborted\n",
			self, source, s);
	else
		fprintf(stderr, "%s: %s -- compilation aborted\n",
			self, s);
	if (codefp) {
		fclose(codefp);
		remove(code);
	}
	exit(1);
}

#define no(n) n, n==1?"":"s"

static
statistics()
{
	int fno, k, n, b, bmax, btotal, n_data;
	for (n = bmax = btotal = k = 0; k < hashtbsz; k++)
		if (hashtb[k] != NONE) {
			n++;
			for (b = -1, fno = hashtb[k]; fno != NONE;
			     b++, fno = symtb[fno].next)
				;
			btotal += b;
			if (b+1>bmax)
				bmax = b+1;
		}
	n_data = strspsz+limbspsz*sizeof(mp_limb_t);
	printf("%d ops in %d module%s, ", codespsz, no(modtbsz));
	printf("%d byte%s data, ", no(n_data));
	printf("%d symbol%s,\n", no(symtbsz));
	printf("%d hash key%s out of %d, %d collision%s, max bucket size = %d\n",
	       no(n), hashtbsz, no(btotal), bmax);
	printf("%d state%s, %d transition%s, %d offset%s\n",
	       no(statetbsz), no(transtbsz), no(roffstbsz));
}

static void *
gmp_allocate (size)
     size_t size;
{
  void *ret;

  ret = malloc (size);
  if (ret == 0) fatal(qcmsg[MEM_OVF]);
  return ret;
}

static void *
gmp_reallocate (oldptr, old_size, new_size)
     void *oldptr;
     size_t old_size;
     size_t new_size;
{
  void *ret;

  ret = realloc (oldptr, new_size);
  if (ret == 0) fatal(qcmsg[MEM_OVF]);
  return ret;
}

static void
gmp_free (blk_ptr, blk_size)
     void *blk_ptr;
     size_t blk_size;
{
  free (blk_ptr);
}

RETSIGTYPE
break_handler()
/* handle SIGINT and SIGTERM */
{
  /* Since many system functions are unsave to call in a signal
     handler, we simply set a flag here; the corresponding actions
     in response to SIGINT (remove code file, close list file,
     terminate program) will be carried out later in a save
     context. */
  int_sig = 1;
  SIGHANDLER_RETURN(0);
}

checkint()
/* check for pending int_sig */
{
  if (int_sig) fatal("interrupt");
}

newrule()
/* reinitialize for the next rule */
{
  clear(); checkint();
}

newdecl()
/* reinitialize for the next declaration */
{
  flags = PRIV; argv = 0; checkint();
}

precval(z)
     mpz_t z;
/* calculate precedence level */
{
  if (my_mpz_fits_slong_p(z)) {
    long prec = mpz_get_si(z);
    if (prec >= 0 && prec <= 9 && prec != 8)
      return prec;
  }
  yyerror(qcmsg[INVALID_PREC]);
  return NONE;
}

priority(z)
     mpz_t z;
/* set a new priority level */
{
  if (my_mpz_fits_slong_p(z))
    prio = mpz_get_si(z);
  else
    yyerror(qcmsg[INVALID_PRIO]);
}

/* qualifier table */

int qual_size, qual_alloc, clause_size, clause_alloc;
static QUAL *qual;
static CLAUSE *clause;

static void start_qualifiers(void)
{
  qual_size = clause_size = 0;
}

static void qualifiers(void)
{
  int i;
  for (i = qual_size-1; i >= 0; i--)
    if (qual[i].x)
      qualifier(qual[i].x);
    else {
      int j;
      for (j = qual[i].start; j < qual[i].end; j++)
	where_clause(clause[j].l, clause[j].r);
    }
}

static void add_qualifier(EXPR *x)
{
  if (!x) return;
  if (qual_size >= qual_alloc)
    if ((qual = arealloc(qual, qual_alloc, 10, sizeof(QUAL))))
      qual_alloc += 10;
    else
      fatal("memory overflow");
  qual[qual_size++].x = x;
}

static void start_where_clauses(void)
{
  if (qual_size >= qual_alloc)
    if ((qual = arealloc(qual, qual_alloc, 10, sizeof(QUAL))))
      qual_alloc += 10;
    else
      fatal("memory overflow");
  qual[qual_size].x = NULL;
  qual[qual_size].start = clause_size;
}

static void end_where_clauses(void)
{
  qual[qual_size++].end = clause_size;
}

static void add_where_clause(EXPR *l, EXPR *r)
{
  if (clause_size >= clause_alloc)
    if ((clause = arealloc(clause, clause_alloc, 10, sizeof(CLAUSE))))
      clause_alloc += 10;
    else
      fatal("memory overflow");
  clause[clause_size].l = l;
  clause[clause_size].r = r;
  clause_size++;
}

/* expression lists */

static xvect_t *exprlist(void)
{
  xvect_t *v = (xvect_t*)malloc(sizeof(xvect_t));
  if (!v) fatal("memory overflow");
  v->a = v->n = 0; v->m = -1;
  v->xv = NULL;
  return v;
}

static xvect_t *addexpr(xvect_t *v, EXPR *x)
{
  if (v->n >= v->a) {
    v->a += 100;
    if (v->xv)
      v->xv = realloc(v->xv, v->a*sizeof(EXPR*));
    else
      v->xv = malloc(v->a*sizeof(EXPR*));
    if (!v->xv) fatal("memory overflow");
  }
  v->xv[v->n++] = x;
  return v;
}

static xvect_t *groupexpr(xvect_t *v)
{
  EXPR *x, *y;
  int n = v->n, m = v->m;
  if (n <= 0) fatal("internal compiler error");
  if (m < 0) m = 0;
  y = v->xv[--n];
  x = funexpr(VOIDOP);
  while (n > m)
    x = pairexpr(v->xv[--n], x);
  v->xv[n++] = x; m = n;
  v->xv[n++] = y;
  v->n = n; v->m = m;
  return v;
}

static EXPR *tupleexpr(xvect_t *v)
{
  EXPR *x;
  int n;
  if (v->m >= 0) groupexpr(v);
  n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = pairexpr(v->xv[--n], x);
  free(v->xv);
  free(v);
  return x;
}

static EXPR *listexpr(xvect_t *v)
{
  EXPR *x;
  int n;
  if (v->m >= 0) groupexpr(v);
  n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = consexpr(v->xv[--n], x);
  free(v->xv);
  free(v);
  return x;
}

static EXPR *streamexpr(xvect_t *v)
{
  EXPR *x;
  int n;
  if (v->m >= 0) groupexpr(v);
  n = v->n;
  if (n <= 0) fatal("internal compiler error");
  x = v->xv[--n];
  while (n > 0)
    x = appexpr(appexpr(funexpr(SCONSOP), v->xv[--n]), x);
  free(v->xv);
  free(v);
  return x;
}

static struct option longopts[] = QC_OPTS;
static struct option all_longopts[] = Q_OPTS;

static int
getintarg(char *s, int *i)
{
  char *t = s;
  while (isspace(*t)) t++;
  s = t;
  while (isdigit(*t)) t++;
  if (t == s) return 0;
  while (isspace(*t)) t++;
  if (*t) return 0;
  *i = atoi(s);
  return 1;
}

static void
parse_opts(argc, argv, pass)
     int argc;
     char **argv;
     int pass; /* 0 denotes source, 1 command line pass */
{
  int c, longind;
  optind = 0;
  while ((c = getopt_long(argc, argv,
			  pass?QC_OPTS1:Q_OPTS1,
			  pass?longopts:all_longopts,
			  &longind)) != EOF)
    switch (c) {
    case QC_PEDANTIC:
      wflag = 2;
      break;
    case QC_NO_PRELUDE:
      prelude = NULL;
      break;
    case QC_PRELUDE:
      prelude = optarg?optarg:prelude;
      break;
    case QC_ENCODING: {
#if defined(HAVE_UNICODE) && defined(HAVE_ICONV)
      if (optarg)
	if (pass) {
	  iconv_t ic = iconv_open("UTF-8", optarg);
	  if (ic == (iconv_t)-1) {
	    char msg[MAXSTRLEN];
	    sprintf(msg, "unknown encoding `%s'", optarg);
	    fatal(msg);
	  } else {
	    iconv_close(ic);
	    default_codeset = optarg;
	  }
	} else /* errors will be caught later by lexer */
	  default_codeset = optarg;
#else
      fprintf(stderr, "%s: warning: --encoding option not supported\n", self);
#endif
      break;
    }
    case 'h':
      hflag = 1;
      break;
    case 'l':
      list = optarg?optarg:list;
      break;
    case 'n':
      nflag = 1;
      break;
    case 'o':
      code = optarg?optarg:code;
      break;
    case 'p':
      if (optarg) {
	change_qpath(optarg);
	if (!qpath) fatal("memory overflow");
      }
      break;
    case 't': {
      int sz;
      if (optarg && getintarg(optarg, &sz) && sz > 0)
	hashtbsz = sz;
      else {
	char msg[MAXSTRLEN];
	sprintf(msg, "invalid size `%s'", optarg?optarg:"");
	fatal(msg);
      }
      break;
    }
    case 'v':
      vflag = 1;
      break;
    case 'w': {
      int level = 1;
      if (optarg && (!getintarg(optarg, &level) || level < 0 || level > 255)) {
	char msg[MAXSTRLEN];
	sprintf(msg, "invalid warning level `%s'", optarg?optarg:"");
	fatal(msg);
      }
      wflag = level;
      break;
    }
    case 'V':
      Vflag = 1;
      break;
    /* interpreter options (ignored): */
    case Q_GNUCLIENT:
    case Q_DEBUG_OPTIONS:
    case Q_BREAK:
    case Q_PROMPT:
    case Q_DEC:
    case Q_HEX:
    case Q_OCT:
    case Q_STD:
    case Q_SCI:
    case Q_FIX:
    case Q_HISTFILE:
    case Q_HISTSIZE:
    case Q_INITRC:
    case Q_NO_INITRC:
    case Q_EXITRC:
    case Q_NO_EXITRC:
    case Q_NO_EDITING:
    case Q_GC_MSGS:
    case Q_GC:
    case Q_STACKSIZE:
    case Q_MEMSIZE:
    case 'd':
    case 'e':
    case 'i':
    case 'q':
    case 'c':
    case 's':
      break;
    default:
      exit(1);
    }
}

static int sargc;
static char **sargv;

static void
get_source_opts(FILE *fp)
{
  char s[MAXSTRLEN];
  int i;

  sargc = 1;
  sargv = aalloc(1, sizeof(char*));
  *sargv = strdup(self);
  while (!feof(fp) && !ferror(fp) &&
	 fgets(s, MAXSTRLEN, fp)) {
    int l = strlen(s);
    if (l > 0 && s[l-1] == '\n') s[l-1] = '\0', l--;
    if (l == 0)
      continue;
    else if (strncmp(s, "#!", 2) == 0)
      if (isspace(s[2])) {
	char *p = s+3;
	while (isspace(*p)) p++;
	sargv = arealloc(sargv, sargc, 1, sizeof(char*));
	sargv[sargc++] = strdup(p);
      } else
	continue;
    else
      break;
  }
  sargv = arealloc(sargv, sargc, 1, sizeof(char*));
  sargv[sargc] = NULL;
}

main(argc, argv)
	int             argc;
	char          **argv;
{
	int c, longind;
	char *s;

#if defined(HAVE_UNICODE) && defined(HAVE_LOCALE_H)
	setlocale(LC_ALL, "");
#endif

#ifdef _WIN32
	InstallSignalHandler();
#endif

	/* get program name: */
	self = argv[0];

	/* get environment settings: */
	if ((s = getenv("QPATH")) != NULL)
	  init_qpath(s);
	else
	  init_qpath(QPATH);
	if (!qpath) fatal("memory overflow");

	/* scan command line to obtain the first source file name: */
	opterr = 0;
	while ((c = getopt_long(argc, argv, Q_OPTS1,
				longopts, &longind)) != EOF)
	  ;
	opterr = 1;

	/* get options from the main script: */
	if (argc-optind >= 1) {
	  char fname[MAXSTRLEN], fname2[MAXSTRLEN];
	  FILE *fp;
	  if (chkfile(searchlib(fname, argv[optind])) &&
	      (fp = fopen(fname, "r")) != NULL ||
	      chkfile(searchlib(fname, strcat(strcpy(fname2, argv[optind]),
					      ".q"))) &&
	      (fp = fopen(fname, "r")) != NULL) {
	    get_source_opts(fp);
	    fclose(fp);
	    parse_opts(sargc, sargv, 0);
	  }
	}

	/* get command line options: */
	parse_opts(argc, argv, 1);
	argc -= optind, argv += optind;

	if (Vflag) {
		printf(signon, version, sysinfo, year);
		printf(copying);
		printf(helpmsg, self);
		exit(0);
	}
	if (hflag) {
		printf(usage, self);
		sprintf(opts, QC_OPTMSG, QPATH, HASHTBSZ);
		fputs(opts, stdout);
		exit(0);
	}

	/* install break and term handlers: */
	sigint(break_handler);
	sigterm(break_handler);
	sighup(break_handler);

	/* install gmp memory handlers */
	mp_set_memory_functions(gmp_allocate, gmp_reallocate, gmp_free);

	/* set code file id: */
	sprintf(outid, OUTID, version, sysinfo);

	/* compile: */
	if (*list) {
	  FILE *fp;
	  if (!(fp = fopen(list, "w"))) {
	    fprintf(stderr, "%s: error creating %s\n",
		    self, list);
	    exit(1);
	  } else {
	    fclose(fp);
	    freopen(list, "w", stderr);
	  }
	}
	if (!(codefp = fopen(code, "wb"))) {
	  fprintf(stderr, "%s: error creating %s\n",
		  self, code);
	  exit(1);
	}
	mainno = -1;
	write_header();
	inittables();
	if (!initlex(argc, argv))
	  /* empty source; skip parse */
	  goto generate;
	if (yyparse() == 0 && nerrs == 0) {
	generate:
	  if (!nflag) {
	    /* generate code: */
	    write_strsp();
	    write_limbsp();
	    write_hashtb();
	    write_symtb();
	    write_TA();
	    write_matchtb();
	    write_inittb();
	    write_modtb();
	    fix_header();
	  }
	  checkint();
	  if (nflag) {
	    fclose(codefp);
	    remove(code);
	  } else
	    fclose(codefp);
	  if (list && !nwarns) {
	    fclose(stderr);
	    remove(list);
	  }
	  if (vflag)
	    if (nflag)
	      printf("(no code generated)\n");
	    else
	      statistics();
	  exit(0);
	} else {
	  checkint();
	  fclose(codefp);
	  remove(code);
	  if (vflag)
	    putchar('\n');
	  exit(1);
	}
}

